
/*-Includes-----------------------------------------------------------------*/
#include <stdafx.h>
#include <winioctl.h>
#include "WinRTctl.h"
#include "R2D3Command.h"
#include "R2D3amcc.h"     //common headers
#include "amcc5933.h"
#include "R2D3DabCtl.h"
#include "StatusThread.h"

#define WHITE 2
#define GREEN 1
#define RED	  0

/*-Globals------------------------------------------------------------------*/
extern AMCC_REGISTERS AmccRegisters;
extern HANDLE hStatus_Display_Event ;
extern HANDLE hWinRTStat;
DWORD	gStatusRegister[16];	//global registers for each status Dword
bool Terminated=false;
bool tick;

/*-Functions----------------------------------------------------------------*/

// Execute method for the status display thread
// Sits in an infinite loop waiting for an event or times out .
//
// Reads the Status register and alarm register then updates the indicators
// for both channels.
UINT statusThreadFunction(LPVOID pParam)
{
	/* Thread sits in an infinite loop */
while(!Terminated)
	{
		// Waits for signal or times out
	WaitForSingleObject(hStatus_Display_Event,400);
		// Read the Status Register
	AfxBeginThread(UpdateDisplayA, NULL, 0,0,0);
	AfxBeginThread(UpdateDisplayB, NULL, 0,0,0);
	ResetEvent(hStatus_Display_Event);
	} // 
	return 1;
}//End of statusThreadFunction method
/*--------------------------------------------------------------------------*/
	
UINT UpdateDisplayA(LPVOID pParam)
{
short status=0;
CString ListItem2;

tick=!tick; //comfort label that shows status is being gathered

int test;
if(tick)
	{
	theApp.dlg->StatusLabel.SetWindowText("tick");
	}
else
	{
	theApp.dlg->StatusLabel.SetWindowText("tock");
	}
	
//    theApp.dlg->listBox2.ResetContent();

for (status=0;status<12;status++)//final read resets status bit
	{
	gStatusRegister[status]=ReadStatus(status);	
	}

    //gets amcc registers then prints them to screen
DumpAmccRegister();
//	PrintStatusRegisters();
//update displays  and controls
UpdateStatReg0A();
UpdateStatReg5A();
UpdateStatReg10A();
char buf[20];
memset(&buf, 0, sizeof(buf));
int temp = (int)(gStatusRegister[2]&WORDS_REMAIN_MASK);
_itoa_s(temp,buf, 16);
theApp.statDlg->sStrARem.SetWindowText(buf);
return 1;
} 
/*--------------------------------------------------------------------------*/
void UpdateStatReg0A(VOID)
{
if (gStatusRegister[0]&STRA_BUFFER_FULL)
  theApp.statDlg->sStrAFull.SetState(RED);
else
	theApp.statDlg->sStrAFull.SetState(WHITE);

if (gStatusRegister[0]&STRA_BUFFER_HALF)
	theApp.statDlg->sStrAHalf.SetState(RED);
else
	theApp.statDlg->sStrAHalf.SetState(WHITE);

if (gStatusRegister[0]&STRA_BUFFER_MT)
	theApp.statDlg->sStrAEmpty.SetState(RED);
else
	theApp.statDlg->sStrAEmpty.SetState(WHITE);

if (gStatusRegister[0]&STRA_THRESH_STATUS)
	theApp.statDlg->sStrATrig.SetState(RED);
else
	theApp.statDlg->sStrATrig.SetState(WHITE);

if (gStatusRegister[0]&ALARM_STATUS)
	theApp.statDlg->sStrAAlarm.SetState(RED);
else
	theApp.statDlg->sStrAAlarm.SetState(WHITE);
}
//--------------------------------------------------------------------
void UpdateStatReg5A(VOID)
{
if (gStatusRegister[5]&STRA_NO_SIGNAL)
	theApp.statDlg->sStrASignal.SetState(RED);
else
	theApp.statDlg->sStrASignal.SetState(GREEN);

if (gStatusRegister[5]&STRA_AIS)
	theApp.statDlg->sStrAAIS.SetState(RED);
else
	theApp.statDlg->sStrAAIS.SetState(GREEN);

if (gStatusRegister[5]&STRA_FAW)
	theApp.statDlg->sStrAFrame.SetState(GREEN);
else
	theApp.statDlg->sStrAFrame.SetState(RED);
//detected frame states
if (gStatusRegister[5]& STRA_FAW)
  {//NA
  if (gStatusRegister[5]& STRA_SIG_F0)
    {//STI/NA G.704=1,F0=1,F1=1
    if(gStatusRegister[5]& STRA_SIG_F1)
		theApp.statDlg->sFrameTypeA.SetWindowText("STI/NA");
    else //not used   G.704=1, F0=1,F1=0
		theApp.statDlg->sFrameTypeA.SetWindowText("Reserved");
    }
  else
    {//ETI/NA   G.704=1, F0=0,F1=1
    if (gStatusRegister[5]& STRA_SIG_F1)
		theApp.statDlg->sFrameTypeA.SetWindowText("ETI/NA");
    else  // G.704=1 , F0=0,F1=0
		theApp.statDlg->sFrameTypeA.SetWindowText("G.704");
    }
  }
else
  { //no FAW
  if (gStatusRegister[5]& STRA_SIG_F0)
    {//STI/NI G.704=0,F0=1,F0=1
    if(gStatusRegister[5]& STRA_SIG_F1)
		theApp.statDlg->sFrameTypeA.SetWindowText("STI/NI");
    else //not used   G.704=0, F0=1,F1=0
		theApp.statDlg->sFrameTypeA.SetWindowText("Reserved");
    }
  else
    {//ETI/NI   G.704=0, F0=0,F1=1
    if (gStatusRegister[5]& STRA_SIG_F1)
		theApp.statDlg->sFrameTypeA.SetWindowText("ETI/NI");
    else  // G.704=0, F0=0,F1=0
		theApp.statDlg->sFrameTypeA.SetWindowText("No Frame");
    }
  }


return;
}
//--------------------------------------------------------------------------------
void UpdateStatReg10A(VOID)
{
if (gStatusRegister[10]&STRA_BUFFER_RESET_STATUS)
	theApp.statDlg->sStrAReset.SetState(WHITE);		
else
	theApp.statDlg->sStrAReset.SetState(RED);

if (gStatusRegister[10]&STRA_ACTIVE_STATUS)
	theApp.statDlg->sStrAActive.SetState(RED);
else
	theApp.statDlg->sStrAActive.SetState(WHITE);

if (gStatusRegister[10]&STRA_RECORD_STATUS)
	theApp.statDlg->sStrARecord.SetState(RED);
else
	theApp.statDlg->sStrARecord.SetState(WHITE);
if (gStatusRegister[10]&STRA_INT_CK_STATUS)
	{
	theApp.statDlg->sStrAIntCk.SetState(RED);
	theApp.ctrlDlg->StrAClk1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrAClk2.SetCheck(BST_CHECKED);
	}
else
	{
	theApp.statDlg->sStrAIntCk.SetState(WHITE);
	theApp.ctrlDlg->StrAClk1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrAClk2.SetCheck(BST_UNCHECKED);
	}

if (gStatusRegister[10]&STRA_ETOE_STATUS)
	{
	theApp.statDlg->sStrAEtoE.SetState(RED);
	theApp.ctrlDlg->StrAByp1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrAByp2.SetCheck(BST_UNCHECKED);
	}
else
	{
	theApp.statDlg->sStrAEtoE.SetState(WHITE);
	theApp.ctrlDlg->StrAByp1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrAByp2.SetCheck(BST_CHECKED);
	}

if (gStatusRegister[10]&STRA_OP_INHIBIT_STATUS)
	{
	theApp.statDlg->sStrAOP.SetState(RED);
	theApp.ctrlDlg->StrAOut1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrAOut2.SetCheck(BST_CHECKED);
	}
else
	{
	theApp.statDlg->sStrAOP.SetState(WHITE);
	theApp.ctrlDlg->StrAOut1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrAOut2.SetCheck(BST_UNCHECKED);
	}

if (gStatusRegister[10]&STR_LOZ_STATUS)//lo (75) or high ohm
	{	// low z
	theApp.statDlg->sStrAHighZ.SetState(WHITE);
	theApp.ctrlDlg->StrAImp1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrAImp2.SetCheck(BST_CHECKED);
	}
else
	{	//high z
	theApp.statDlg->sStrAHighZ.SetState(RED);
	theApp.ctrlDlg->StrAImp1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrAImp2.SetCheck(BST_UNCHECKED);
	}

//commanded frame states
if (gStatusRegister[10]& AUTO_FRAME_STATUS)
	{//auto framing
  theApp.statDlg->sStrAutoFrame.SetState(RED);
  theApp.ctrlDlg->StrAutoFrm.SetCheck(BST_CHECKED);
  theApp.ctrlDlg->StrManFrm.SetCheck(BST_UNCHECKED);
  }
else
	{//manual framing
  theApp.statDlg->sStrAutoFrame.SetState(WHITE);
  theApp.ctrlDlg->StrAutoFrm.SetCheck(BST_UNCHECKED);
  theApp.ctrlDlg->StrManFrm.SetCheck(BST_CHECKED);
  
  if (gStatusRegister[10]& STRA_G704_FRAME_STATUS)
	  {
    theApp.statDlg->sStrAG704.SetState(RED);
	  if(gStatusRegister[10]&STRA_F0_STATUS)
	    {
      if(gStatusRegister[10]&STRA_F1_STATUS)
	      { //STI/NA  G.704=1, F0=1,F1=1,
	      theApp.ctrlDlg->StrASNA.SetCheck(BST_CHECKED);
	      theApp.ctrlDlg->StrAENA.SetCheck(BST_UNCHECKED);
	      theApp.ctrlDlg->StrAENI.SetCheck(BST_UNCHECKED);
	      theApp.ctrlDlg->StrASNI.SetCheck(BST_UNCHECKED);
 	      theApp.ctrlDlg->StrAUnf.SetCheck(BST_UNCHECKED);
        }
      }
    else
      {//F0=0
		  if (gStatusRegister[10]& STRA_F1_STATUS)
		    {  //ETI/NA  G.704=1, F0=0,F1=1
	      theApp.ctrlDlg->StrAENA.SetCheck(BST_CHECKED);
        }
		  else
			  {//G.704 NA only  0,0 , G.704=1
	      theApp.ctrlDlg->StrAG74.SetCheck(BST_CHECKED);
        }
		  }
    }
  else//not G.704
	  {
    theApp.statDlg->sStrAG704.SetState(WHITE);
	  if(gStatusRegister[10]&STRA_F0_STATUS)
	    {
		  if(gStatusRegister[10]&STRA_F1_STATUS)
		    { //STI/NI  1,1, G.704=0
	      theApp.ctrlDlg->StrASNI.SetCheck(BST_CHECKED);
			  }
		  }
	  else
		  {//F0=0
		  if (gStatusRegister[10]& STRA_F1_STATUS)
	      { //ETI/NI  0,1  ,G.704=0
	      theApp.ctrlDlg->StrAENI.SetCheck(BST_CHECKED);
			  }
		  else
			  {//Unframed  0,0 , G.704=0
        theApp.ctrlDlg->StrAUnf.SetCheck(BST_CHECKED);
  		  }
		  }
	  }
  }
		//}


if (gStatusRegister[10]& STRA_F0_STATUS)
	theApp.statDlg->sStrAF0.SetState(RED);
else
	theApp.statDlg->sStrAF0.SetState(WHITE);

if (gStatusRegister[10]& STRA_F1_STATUS)
	theApp.statDlg->sStrAF1.SetState(RED);
else
	theApp.statDlg->sStrAF1.SetState(WHITE);


}
//----------------------------------------------------------------
UINT  UpdateDisplayB(LPVOID pParam)
{
short status=0;
static bool tick=0;
CString ListItem2;
    
for (status=0;status<10;status++)//final read resets status bit
	{
	gStatusRegister[status]=ReadStatus(status);
	}
	//update displays  and controls
	
UpdateStatReg0B();
UpdateStatReg5B();
UpdateStatReg10B();

char buf[20];
memset(&buf, 0, sizeof(buf));
int temp = (int)(gStatusRegister[3]&WORDS_REMAIN_MASK);
_itoa_s(temp,buf, 16);
theApp.statDlg->sStrBRem.SetWindowText(buf);
return 1;
} // End of UpdateDisplay method
//---------------------------------------------------------------------
void UpdateStatReg0B(VOID)
{
if (gStatusRegister[0]&STRB_BUFFER_FULL)
	theApp.statDlg->sStrBFull.SetState(RED);
else
	theApp.statDlg->sStrBFull.SetState(WHITE);

if (gStatusRegister[0]&STRB_BUFFER_HALF)
	theApp.statDlg->sStrBHalf.SetState(RED);
else
	theApp.statDlg->sStrBHalf.SetState(WHITE);

if (gStatusRegister[0]&STRB_BUFFER_MT)
	theApp.statDlg->sStrBEmpty.SetState(RED);
else
	theApp.statDlg->sStrBEmpty.SetState(WHITE);

if (gStatusRegister[0]&STRB_THRESH_STATUS)
	theApp.statDlg->sStrBTrig.SetState(RED);
else
	theApp.statDlg->sStrBTrig.SetState(WHITE);

}
/*--------------------------------------------------------------------------*/
void UpdateStatReg5B(VOID)
{
if (gStatusRegister[5]&STRB_NO_SIGNAL)
	theApp.statDlg->sStrBSignal.SetState(RED);
else
	theApp.statDlg->sStrBSignal.SetState(GREEN);
	
if (gStatusRegister[5]&STRB_AIS)
	theApp.statDlg->sStrBAIS.SetState(RED);
else
	theApp.statDlg->sStrBAIS.SetState(GREEN);
	
if (gStatusRegister[5]&STRB_FAW)
	theApp.statDlg->sStrBFrame.SetState(GREEN);
else
	theApp.statDlg->sStrBFrame.SetState(RED);

//detected frame states
if (gStatusRegister[5]& STRB_FAW)
  {//NA
  if (gStatusRegister[5]& STRB_SIG_F0)
    {//STI/NA G.704=1,F0=1,F1=1
    if(gStatusRegister[5]& STRB_SIG_F1)
		theApp.statDlg->sFrameTypeB.SetWindowText("STI/NA");
    else //not used   G.704=1, F0=1,F1=0
		theApp.statDlg->sFrameTypeB.SetWindowText("Reserved");
    }
  else
    {//ETI/NA   G.704=1, F0=0,F1=1
    if (gStatusRegister[5]& STRB_SIG_F1)
		theApp.statDlg->sFrameTypeB.SetWindowText("ETI/NA");
    else  // G.704=1 , F0=0,F1=0
		theApp.statDlg->sFrameTypeB.SetWindowText("G.704");
    }
  }
else
  { //no FAW
  if (gStatusRegister[5]& STRA_SIG_F0)
    {//STI/NI G.704=0,F0=1,F0=1
    if(gStatusRegister[5]& STRA_SIG_F1)
		theApp.statDlg->sFrameTypeB.SetWindowText("STI/NI");
    else //not used   G.704=0, F0=1,F1=0
		theApp.statDlg->sFrameTypeB.SetWindowText("Reserved");
    }
  else
    {//ETI/NI   G.704=0, F0=0,F1=1
    if (gStatusRegister[5]& STRA_SIG_F1)
		theApp.statDlg->sFrameTypeB.SetWindowText("ETI/NI");
    else  // G.704=0, F0=0,F1=0
		theApp.statDlg->sFrameTypeB.SetWindowText("No Frame");
    }
  }

}
/*--------------------------------------------------------------------------*/
void UpdateStatReg10B(VOID)
{
if (gStatusRegister[10]&STRB_BUFFER_RESET_STATUS)
	theApp.statDlg->sStrBReset.SetState(WHITE);
else
	theApp.statDlg->sStrBReset.SetState(RED);
if (gStatusRegister[10]&STRB_ACTIVE_STATUS)
	theApp.statDlg->sStrBActive.SetState(RED);
else
	theApp.statDlg->sStrBActive.SetState(WHITE);
if (gStatusRegister[10]&STRB_RECORD_STATUS)
	theApp.statDlg->sStrBRecord.SetState(RED);
else
	theApp.statDlg->sStrBRecord.SetState(WHITE);

if (gStatusRegister[10]&STRB_INT_CK_STATUS)
	{
	theApp.statDlg->sStrBIntCk.SetState(RED);
	theApp.ctrlDlg->StrBClk1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrBClk2.SetCheck(BST_CHECKED);
	}
else
	{
	theApp.statDlg->sStrBIntCk.SetState(WHITE);
	theApp.ctrlDlg->StrBClk1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrBClk2.SetCheck(BST_UNCHECKED);
	}

if (gStatusRegister[10]&STRB_ETOE_STATUS)
	{
	theApp.statDlg->sStrBEtoE.SetState(RED);
	theApp.ctrlDlg->StrBByp1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrBByp2.SetCheck(BST_UNCHECKED);
	}
else
	{
	theApp.statDlg->sStrBEtoE.SetState(WHITE);
	theApp.ctrlDlg->StrBByp1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrBByp2.SetCheck(BST_CHECKED);
	}

if (gStatusRegister[10]&STRB_OP_INHIBIT_STATUS)
	{
	theApp.statDlg->sStrBOP.SetState(RED);
	theApp.ctrlDlg->StrBOut1.SetCheck(BST_UNCHECKED);
	theApp.ctrlDlg->StrBOut2.SetCheck(BST_CHECKED);
	}
else
	{
	theApp.statDlg->sStrBOP.SetState(WHITE);
	theApp.ctrlDlg->StrBOut1.SetCheck(BST_CHECKED);
	theApp.ctrlDlg->StrBOut2.SetCheck(BST_UNCHECKED);
	}
//commanded frame states

if (gStatusRegister[10]& STRB_F0_STATUS)
	theApp.statDlg->sStrBF0.SetState(RED);
else
	theApp.statDlg->sStrBF0.SetState(WHITE);

if (gStatusRegister[10]& STRB_F1_STATUS)
	theApp.statDlg->sStrBF1.SetState(RED);
else
	theApp.statDlg->sStrBF1.SetState(WHITE);
if (gStatusRegister[10]& STRB_G704_FRAME_STATUS)
	{
  theApp.statDlg->sStrBG704.SetState(RED);
	if(gStatusRegister[10]&STRB_F0_STATUS)
	  {
    if(gStatusRegister[10]&STRB_F1_STATUS)
	    { //STI/NA  G.704=1, F0=1,F1=1,
	    theApp.ctrlDlg->StrBSNA.SetCheck(BST_CHECKED);
	    theApp.ctrlDlg->StrBENA.SetCheck(BST_UNCHECKED);
	    theApp.ctrlDlg->StrBENI.SetCheck(BST_UNCHECKED);
	    theApp.ctrlDlg->StrBSNI.SetCheck(BST_UNCHECKED);
 	    theApp.ctrlDlg->StrBUnf.SetCheck(BST_UNCHECKED);
     }
    }
  else
    {//F0=0
		if (gStatusRegister[10]& STRB_F1_STATUS)
		  {  //ETI/NA  G.704=1, F0=0,F1=1
	    theApp.ctrlDlg->StrBENA.SetCheck(BST_CHECKED);
      }
		else
			{//G.704 NA only  0,0 , G.704=1
	    theApp.ctrlDlg->StrBG74.SetCheck(BST_CHECKED);
      }
		}
  }
else//not G.704
	{
  theApp.statDlg->sStrBG704.SetState(WHITE);
	if(gStatusRegister[10]&STRB_F0_STATUS)
	  {
		if(gStatusRegister[10]&STRB_F1_STATUS)
		  { //STI/NI  1,1, G.704=0
	    theApp.ctrlDlg->StrBSNI.SetCheck(BST_CHECKED);
			}
		}
	else
		{//F0=0
		if (gStatusRegister[10]& STRB_F1_STATUS)
	    { //ETI/NI  0,1  ,G.704=0
	    theApp.ctrlDlg->StrBENI.SetCheck(BST_CHECKED);
			}
		else
			{//Unframed  0,0 , G.704=0
      theApp.ctrlDlg->StrBUnf.SetCheck(BST_CHECKED);
  		}
		}
	}
		//}


}
//---------------------------------------------------------------------
DWORD  ReadStatus(int status)
{
DWORD WriteData=0;
DWORD MailData1=0;
DWORD TempData=0;
CString ListItem;
int MailBoxAddress=0;
DWORD OffsetStatus=0;

MailData1=gStatusRegister[status] ; //save current register value
WriteData|=STATUS_REQUEST; //preserved interrupt command
switch (status)
	{
	case 0:
		OffsetStatus=OFFSET_0;
        WriteData|=(STATUS_A|OffsetStatus);   //Status A
		MailBoxAddress=IMB1;
		break;
	case 1:
		OffsetStatus=OFFSET_0;
        WriteData|=(STATUS_B|OffsetStatus); ////Status B, offset 0 XFIFO words rem

        MailBoxAddress=IMB2;
		break;
	case 2:
		OffsetStatus=OFFSET_1;
		WriteData|=(STATUS_B|OffsetStatus);  //Status B offset1  StrA Words Rem
        MailBoxAddress=IMB2;
		break;
	case 3:
		OffsetStatus=OFFSET_2;
        WriteData|=(STATUS_B|OffsetStatus);//Status B offset 2  StrB Words Rem
        MailBoxAddress=IMB2;
		break;
	case 4:
		OffsetStatus=OFFSET_3;
        WriteData|=(STATUS_B|OffsetStatus); //Status B offset 3  Buffer  Thresholds
        MailBoxAddress=IMB2;
		break;
	case 5:
		OffsetStatus=OFFSET_0;
		WriteData|=(STATUS_C|OffsetStatus); //status C offset 0,signal etc
		MailBoxAddress=IMB3;
		break;
	case 6:
		OffsetStatus=OFFSET_1;
		WriteData|=(STATUS_C|OffsetStatus);//status C offset 1, reserved, 
        MailBoxAddress=IMB3;
		break;
	case 7:
		OffsetStatus=OFFSET_2;
		WriteData|=(STATUS_C|OffsetStatus);//status C offset 2, Firmware, 
        MailBoxAddress=IMB3;
		break;
	case 8:OffsetStatus=OFFSET_3;
        WriteData|=(STATUS_C|OffsetStatus);//status C offset 3, S/N  LSB
        MailBoxAddress=IMB3;
		break;
	case 9:OffsetStatus=OFFSET_4;
        WriteData|=(STATUS_C|OffsetStatus);//status C offset 4, S/N MSB
        MailBoxAddress=IMB3;
		 break;
	case 10:OffsetStatus=OFFSET_5;
        WriteData|=(STATUS_C|OffsetStatus);//status C offset 5, S/N card stream states
        MailBoxAddress=IMB3;
		break;
	case 11:OffsetStatus=OFFSET_0;
         WriteData|=(STATUS_D|OffsetStatus);  //interrupt source
         MailBoxAddress=IMB4;
		break;
	case 12:OffsetStatus=OFFSET_0;
         WriteData&=~STATUS_REQUEST;//|OffsetStatus);  //words remain stream B
         MailBoxAddress=0;
		break;
  	}

WriteMailBox1(OMB1,  WriteData);
if(MailBoxAddress!=0) //for reset
	ReadMailBox1(MailBoxAddress,&TempData);
	//only updates status if offsets match
if(status==11)
	{
	if((TempData<<8&OFFSET_MASK)==OffsetStatus)
		MailData1=TempData; //update status, otherwise return original status
	}
else
	if((TempData&OFFSET_MASK)==OffsetStatus)
		MailData1=TempData; //update status, otherwise return original status

return (MailData1);//update status register on return
}
/*--------------------------------------------------------------------------*/
DWORD  DumpAmccRegister()
{
DWORD           status;
status = GetAmccRegisters(&AmccRegisters);
if (status != ERROR_SUCCESS) {
  Beep(500,200);
  return status;
  }
PrintAmccAndStatusRegisters(&AmccRegisters);
return ERROR_SUCCESS;
}
/*--------------------------------------------------------------------------*/

 /////////////////////////////////////////////////////////////////////
//  GetAmccRegisters - Get AMCC5933 register values
//  Inputs: pAmccRegisters - storage location for registervalues
//  Outputs:
//  Notes:
//////////////////////////////////////////////////////////////////////
DWORD  GetAmccRegisters(PAMCC_REGISTERS pAmccRegisters)
{
DWORD       Error;                  // error return value
DWORD       iWinRTlength;           // length from the driver

{
WINRT_CONTROL_ITEM _WinRTpp06[] =
  {//	command	param1	param2
			{DIM,	0x00040001,	 0x0},	// L:0 OMB1
			{DIM,	0x00040001,	 0x0},	// L:1 OMB2
			{DIM,	0x00040001,	 0x0},	// L:2 OMB3
			{DIM,	0x00040001,	 0x0},	// L:3 OMB4
			{DIM,	0x00040001,	 0x0},	// L:4 IMB1
			{DIM,	0x00040001,	 0x0},	// L:5 IMB2
  			{DIM,	0x00040001,	 0x0},	// L:6 IMB3
			{DIM,	0x00040001,	 0x0},	// L:7 IMB4
			{DIM,	0x00040001,	 0x0},	// L:8 MWAR
			{DIM,	0x00040001,	 0x0},	// L:9 MWTC
			{DIM,	0x00040001,	 0x0},	// L:10 MRAR
			{DIM,	0x00040001,	 0x0},	// L:11 MRTC
			{DIM,	0x00040001,	 0x0},	// L:12 MBEF
			{DIM,	0x00040001,	 0x0},	// L:13 INTCSR
			{DIM,	0x00040001,	 0x0},	// L:14 MCSR
	 		{INP_L,	0,	0},
	 		{MATH,	0x000D000C,	0x000C4000}, //MBEF
			{INP_L,	0,	0},
			{MATH,	0x000D0000,	0x00004000}, //OMB1
			{INP_L,	0,	0},
			{MATH,	0x000D0001,	0x00014000}, //OMB2
			{INP_L,	0,	0},
			{MATH,	0x000D0002,	0x00024000}, //OMB3
			{INP_L,	0,	0},
			{MATH,	0x000D0003,	0x00034000}, //OMB4
			{INP_L,	0,	0},
			{MATH,	0x000D0004,	0x00044000},//IMB1
			{INP_L,	0,	0},
			{MATH,	0x000D0005,	0x00054000},//IMB2
			{INP_L,	0,	0},
			{MATH,	0x000D0006,	0x00064000},//IMB3
			{INP_L,	0,	0},
			{MATH,	0x000D0007,	0x00074000},//IMB4
			{INP_L,	0,	0},
			{MATH,	0x000D0008,	0x00084000},
			{INP_L,	0,	0},
			{MATH,	0x000D0009,	0x00094000},
			{INP_L,	0,	0},
			{MATH,	0x000D000A,	0x000A4000},
			{INP_L,	0,	0},
			{MATH,	0x000D000B,	0x000B4000},
			{INP_L,	0,	0},
			{MATH,	0x000D000D,	0x000D4000},
			{INP_L,	0,	0},
			{MATH,	0x000D000E,	0x000E4000},
		};
		_WinRTpp06[15].port = AMCC5933MailboxStatus;
		_WinRTpp06[17].port = AMCC5933OutgoingMailbox1;
		_WinRTpp06[19].port = AMCC5933OutgoingMailbox2;
		_WinRTpp06[21].port = AMCC5933OutgoingMailbox3;
		_WinRTpp06[23].port = AMCC5933OutgoingMailbox4;
		_WinRTpp06[33].port = AMCC5933MasterWriteAddress;
		_WinRTpp06[35].port = AMCC5933MasterWriteTransferCount;
		_WinRTpp06[37].port = AMCC5933MasterReadAddress;
		_WinRTpp06[39].port = AMCC5933MasterReadTransferCount;
		_WinRTpp06[41].port = AMCC5933InterruptControlStatus;
		_WinRTpp06[43].port = AMCC5933BusMasterControlStatus;
		if (!WinRTProcessIoBufferDirect(hWinRTStat, _WinRTpp06, sizeof(_WinRTpp06), &iWinRTlength))
			goto getRegistersError;
		pAmccRegisters->OutgoingMailbox1 = (ULONG)_WinRTpp06[ 0].value;
		pAmccRegisters->OutgoingMailbox2 = (ULONG)_WinRTpp06[ 1].value;
		pAmccRegisters->OutgoingMailbox3 = (ULONG)_WinRTpp06[ 2].value;
		pAmccRegisters->OutgoingMailbox4 = (ULONG)_WinRTpp06[ 3].value;
		pAmccRegisters->MasterWriteAddress = (ULONG)_WinRTpp06[ 8].value;
		pAmccRegisters->MasterWriteTransferCount = (ULONG)_WinRTpp06[ 9].value;
		pAmccRegisters->MasterReadAddress = (ULONG)_WinRTpp06[10].value;
		pAmccRegisters->MasterReadTransferCount = (ULONG)_WinRTpp06[11].value;
		pAmccRegisters->MailboxStatus = (ULONG)_WinRTpp06[12].value;
		pAmccRegisters->InterruptControlStatus = (ULONG)_WinRTpp06[13].value;
		pAmccRegisters->BusMasterControlStatus = (ULONG)_WinRTpp06[14].value;
	}
	
return (ERROR_SUCCESS);

getRegistersError:
    Error = GetLastError();
    
theApp.dlg->LabelError.SetWindowText("GetAmccRegisters() failed :  " + Error);
    return (Error);
}
/*--------------------------------------------------------------------------*/

void  PrintAmccAndStatusRegisters(PAMCC_REGISTERS pAmccRegisters)
{
CString ListItem2;

ListItem2.Format(_T("OutgoingMailbox1 - %.8X\r\n"), (int)pAmccRegisters->OutgoingMailbox1);
	
ListItem2.AppendFormat(_T("OutgoingMailbox2 - %.8X\r\n"), (int)pAmccRegisters->OutgoingMailbox2);

ListItem2.AppendFormat(_T("OutgoingMailbox3 - %.8X\r\n"), (int)pAmccRegisters->OutgoingMailbox3);
	
ListItem2.AppendFormat(_T("OutgoingMailbox4 - %.8X\r\n"), (int)pAmccRegisters->OutgoingMailbox4);

ListItem2.AppendFormat(_T("MasterWriteAddress - %.8X\r\n"), (int)pAmccRegisters->MasterWriteAddress);

ListItem2.AppendFormat(_T("MasterWriteTransferCount - %.8X\r\n"), (int)pAmccRegisters->MasterWriteTransferCount);

ListItem2.AppendFormat(_T("MasterReadAddress - %.8X\r\n"), (int)pAmccRegisters->MasterReadAddress);

ListItem2.AppendFormat(_T("MasterReadTransferCount - %.8X\r\n"), (int)pAmccRegisters->MasterReadTransferCount);

ListItem2.AppendFormat(_T("MailboxStatus - %.8X\r\n"), (int)pAmccRegisters->MailboxStatus);

ListItem2.AppendFormat(_T("InterruptControlStatus- %.8X\r\n"), (int)pAmccRegisters->InterruptControlStatus);

ListItem2.AppendFormat(_T("BusMasterControlStatus - %.8X\r\n"), (int)pAmccRegisters->BusMasterControlStatus);

ListItem2.AppendFormat(_T("IncomingMailbox1,0 - %.8X\r\n"), (int)gStatusRegister[0]);
ListItem2.AppendFormat(_T("IncomingMailbox2,0 - %.8X\r\n"), (int)gStatusRegister[1]);
ListItem2.AppendFormat(_T("IncomingMailbox2,1 - %.8X\r\n"), (int)gStatusRegister[2]);
ListItem2.AppendFormat(_T("IncomingMailbox2,2 - %.8X\r\n"), (int)gStatusRegister[3]);
ListItem2.AppendFormat(_T("IncomingMailbox2,3 - %.8X\r\n"), (int)gStatusRegister[4]);
ListItem2.AppendFormat(_T("IncomingMailbox3,0 - %.8X\r\n"), (int)gStatusRegister[5]);
ListItem2.AppendFormat(_T("IncomingMailbox3,1 - %.8X\r\n"), (int)gStatusRegister[6]);
ListItem2.AppendFormat(_T("IncomingMailbox3,2 - %.8X\r\n"), (int)gStatusRegister[7]);
ListItem2.AppendFormat(_T("IncomingMailbox3,3 - %.8X\r\n"), (int)gStatusRegister[8]);
ListItem2.AppendFormat(_T("IncomingMailbox3,4 - %.8X\r\n"), (int)gStatusRegister[9]);
ListItem2.AppendFormat(_T("IncomingMailbox3,5 - %.8X\r\n"), (int)gStatusRegister[10]);
ListItem2.AppendFormat(_T("IncomingMailbox4,0 - %.8X\r\n"), (int)gStatusRegister[11]);
theApp.dlg->display2.SetWindowText(ListItem2);

	return;
}
/*--------------------------------------------------------------------------*/
/*
Lists status registers in hex format
*/
/*
void  PrintStatusRegisters(void)
{
	CString ListItem2;
	ListItem2.Format(_T("IncomingMailbox1,0 - %.8X"), (int)gStatusRegister[0]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox2,0 - %.8X"), (int)gStatusRegister[1]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox2,1 - %.8X"), (int)gStatusRegister[2]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox2,3 - %.8X"), (int)gStatusRegister[3]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox3,0 - %.8X"), (int)gStatusRegister[4]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox3,1 - %.8X"), (int)gStatusRegister[5]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox4,0 - %.8X"), (int)gStatusRegister[6]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox4,1 - %.8X"), (int)gStatusRegister[7]);
	theApp.dlg->listBox2.AddString(ListItem2);

	ListItem2.Format(_T("IncomingMailbox4,2 - %.8X"), (int)gStatusRegister[8]);
	theApp.dlg->listBox2.AddString(ListItem2);
}*/
/*--------------------------------------------------------------------------*/
