
/*--Includes--------------------------------------------------------------*/
#pragma once
#include "stdafx.h"
#include <memory.h>
#include <winioctl.h>
#include "BufferThread.h"
#include "StatusThread.h"
#include "ControlDlg.h"
#include "InterruptThread.h"
#include "winrtctl.h"
#include "R2D3DABCtl.h"
#include "amcc5933.h"
#include "R2D3Record.h"

/*--Defines---------------------------------------------------------------*/

/*--Globals---------------------------------------------------------------*/

extern HANDLE hWinRTBuff;
extern WINRT_DMA_BUFFER_INFORMATION  DmaBufferInfo; //DMA buffer information
extern HANDLE hDMAWriteCompleteEvent;
extern HANDLE hDMAReadCompleteEvent;
extern HANDLE hBufferEventA;
extern HANDLE hBufferGoEvent;
extern HANDLE hBufferEventB;
extern HANDLE hHiThreshIntEvent;
extern CBufferThread *pBufferThread;
extern CInterruptThread *pInterruptThread;
HANDLE BufferThreadFinishedEvent;
//extern CRITICAL_SECTION csStatusUpdate;



/*--Methods---------------------------------------------------------------*/

// Stub
UINT CBufferThread::mtstub1(LPVOID xthis)
{
	CBufferThread *_this=(CBufferThread *)xthis; 
	_this->Execute();
	return 0;
}
/*------------------------------------------------------------------------*/
//Constructor
CBufferThread::CBufferThread()
{
memset(DataBuffer1, 0xAA, sizeof(DataBuffer1));
memset(DataBuffer2, 0xBB, sizeof(DataBuffer2));
	//FillMemory(&DataBuffer1,sizeof(DataBuffer1),0xAA)  ;
	//FillMemory(&DataBuffer2,sizeof(DataBuffer2),0xBB)  ;
NumBytes=65536;
AmccBytes = 32;
Terminated = false;
BufferThreadFinishedEvent  = CreateEvent(NULL, true ,false, NULL);
AfxBeginThread(mtstub1, this,THREAD_PRIORITY_ABOVE_NORMAL, 0, 0);
}
/*------------------------------------------------------------------------*/

void CBufferThread::Execute()
{
	DWORD WaitResult=0;
	CString buffer;
	//BufferTransferA();
	//BufferTransferB();
theApp.dlg->gInterruptCommand=0;
EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
	BufferPages=(R2D3_BUF_SIZE/2)/NumBytes;//
	while(!Terminated)
	{      //wait for go button and threshold to be set
		ResetEvent(BufferThreadFinishedEvent);
		WaitResult = WaitForSingleObject(hBufferGoEvent,INFINITE);
		WaitResult = WaitForSingleObject(hHiThreshIntEvent,6000);
		if(Terminated)
      break;
    ResetEvent(hHiThreshIntEvent);
		if(WaitResult==WAIT_OBJECT_0)//hi threshold
		{
			if(pInterruptThread->DataSourceA)
				BufferTransferA();
			if(pInterruptThread->DataSourceB)
				BufferTransferB();

			//enable incoming mailbox interrupt
			theApp.dlg->gInterruptCommand|= S5933_INTCSR_INCOMING_INTERRUPT;
			EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		}
		if(WaitResult==WAIT_TIMEOUT)//
		{
			buffer.Format(_T("Buffer Transfer: Timeout %d"), WaitResult);
			theApp.dlg->LabelError.SetWindowText(buffer);
			//theApp.dlg->LabelError.SetWindowText("Buffer Transfer: Timeout "
			//			+ WaitResult);
		}
		SetEvent(BufferThreadFinishedEvent);
		//Application->ProcessMessages();
	}
	header_write_end1(&theApp.strA);
	header_write_end1(&theApp.strB);
}
/*------------------------------------------------------------------------*/

void CBufferThread::BufferTransferA()
{
int n=0;
DWORD TempData;
int BytesRem;
BytesRem =GetBytesRem(1);
if(BytesRem>0)
  {
  BufferPages=(BytesRem/NumBytes)-1;//transfer half buffer in Numbyte chunks
//	BufferPages=(R2D3_BUF_SIZE/2)/ NumBytes; //half the card buffer size

  theApp.dlg->gCommand2|=STRA_DATA_REQ|REC_XFIFO_REQ;
  WriteMailBox1(OMB2, theApp.dlg->gCommand2);

  ResetEvent(hDMAWriteCompleteEvent);
  for(n=0;n<BufferPages;n++)//get data from card
	  {
	  if(!Terminated)
		  {
		  ReadFromCard(NumBytes,true);
		  DiskWriteA( DataBuffer1,NumBytes);
		  }
	  }
  theApp.dlg->gCommand2&=~STRA_DATA_REQ;
  WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	//flush fifo
  FifoBytes=GetBytesRem(0);
	if(FifoBytes>0)// && !Terminated)
	  {
		ReadFromCard(FifoBytes,true);//stream A
		DiskWriteA( DataBuffer1,FifoBytes);
	  }
	if(!Terminated)
	  {
		ReadFromCard(AmccBytes,true);//stream A
		DiskWriteA( DataBuffer1,AmccBytes);
	  }

	//end of flush
	theApp.dlg->gCommand2&=~STRA_DATA_REQ&~REC_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);
  }
}
/*------------------------------------------------------------------------*/
void CBufferThread::BufferTransferB()
{
	int n=0;
	DWORD TempData;
int BytesRem;
BytesRem =GetBytesRem(2);
if(BytesRem>0)
  {  
  BufferPages=(BytesRem/NumBytes)-1;//transfer half buffer in Numbyte chunks
//	BufferPages=(R2D3_BUF_SIZE/2)/ NumBytes; //half the card buffer size

	theApp.dlg->gCommand2|=STRB_DATA_REQ|REC_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	ResetEvent(hDMAWriteCompleteEvent);
	for(n=0;n<BufferPages;n++)//get data from card
	  {
		if(!Terminated)
		  {
			ReadFromCard(NumBytes,false);
			DiskWriteB( DataBuffer2,NumBytes);
		  }
	  }
	theApp.dlg->gCommand2&=~STRB_DATA_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	//flush fifo
	FifoBytes=GetBytesRem(0);
	if(FifoBytes>0 )//&& !Terminated)
	  {
		ReadFromCard(FifoBytes,false);//stream B
		DiskWriteB( DataBuffer2,FifoBytes);
	  }
	if(!Terminated)
	  {
		ReadFromCard(AmccBytes,false);//stream B
		DiskWriteB( DataBuffer2,AmccBytes);
	  }
	//end of flush
	theApp.dlg->gCommand2&=~STRB_DATA_REQ&~REC_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);
  }
}
/*------------------------------------------------------------------------*/
void CBufferThread::ReadFromCard(int ReadSize,bool StreamA)
{
	DWORD WaitTimeout;
	int n;
	ResetEvent(hDMAWriteCompleteEvent);

	if(ReadSize>0)
	{
		DmaReadFifo(ReadSize);
		WaitTimeout=WaitForSingleObject(hDMAWriteCompleteEvent,15000);
		if(WaitTimeout==WAIT_OBJECT_0)
		{
			if(StreamA)
				CopyMemory(DataBuffer1, DmaBufferInfo.pVirtualAddress,ReadSize);
			else
				CopyMemory(DataBuffer2, DmaBufferInfo.pVirtualAddress,ReadSize);
			ResetEvent(hDMAWriteCompleteEvent);
		}
		if(WaitTimeout == WAIT_TIMEOUT )
		{      //debug messages
			theApp.dlg->LabelError.SetWindowText("Buffer: DMA write complete failed");// + IntToStr(WaitTimeout);
		}
	}
}

/*------------------------------------------------------------------------*/
//////////////////////////////////////////////////////////////////////
//  DmaReadFifo - sets up read DMA, uses interrupt in Interrupt thread
//  Inputs: Length - Dma read length
//  Outputs:
//  Notes:
//////////////////////////////////////////////////////////////////////
DWORD CBufferThread::DmaReadFifo(DWORD Length)
{
	DWORD       Error=0;       // error return value
	DWORD       Address=0;  // address of WinRT common buffer (logical address)
	DWORD       iWinRTlength=0;     // length from the driver
	CString		buffer;


	if((Length < 4) || (Length > DmaBufferInfo.Length)) // check for valid length
	{
		buffer.Format(_T("BufferReadFifo: Invalid Length %d valid range 4-%d"), 
						  Length,
						  DmaBufferInfo.Length);
		theApp.dlg->LabelError.SetWindowText(buffer);
		return(ERROR_INVALID_DATA);
	}

	if (Length & 0x3)                   //} check that length can be
	{									//} converted into ULONG count (4byte chunks)
		theApp.dlg->LabelError.SetWindowText("DmaReadFifo: Invalid Length,  must be on a DWORD boundary");
		return (ERROR_INVALID_DATA);
	}
					// get common buffer address for DMA (logical)
	Address = (DWORD)(DmaBufferInfo.LogicalAddress);

	{
		static WINRT_CONTROL_ITEM _WinRTpp01[] =
		{//	command	param1	param2
			{DIM,	0x00040001,	 0x0},	// L:0 DmaMask
			{DIM,	0x00040001,	 0x0},	// L:1 StartDMA
			{DIM,	0x00040001,	 0x0},	// L:2 DmaControl
			{DIM,	0x00040001,	 0x0},	// L:3 Temp
			{OUTP_L,	0,	0},         //4
			{OUTP_L,	0,	0},
			{WINRT_TRACE,	0x00000000,	0x00000024},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{WINRT_TRACE,	0x00000000,	0x00000025},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{INP_L,	0,	0},
			{MATH,	0x000D0002,	0x00024000},
			{MATH,	0x00080003,	0x00020000},
			{MATH,	0x00090002,	0x00030001},
			{MATH,	0x000D0002,	0x00021000},
			{WINRT_TRACE,	0x00000000,	0x00000033},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{MATH,	0x000D0002,	0x00022000},
			{OUTP_L,	0,	0},
		};
		_WinRTpp01[ 0].value = (ULONG)S5933_MCSR_DMA_MASK;//0x0000FF00
		_WinRTpp01[ 1].value = (ULONG)S5933_MCSR_WRITE_TRANSFER_ENABLE;//(1<<10)
		_WinRTpp01[ 4].port = AMCC5933MasterWriteAddress;
		_WinRTpp01[ 4].value = Address;// address of WinRT common buffer (logical address)
		_WinRTpp01[ 5].port = AMCC5933MasterWriteTransferCount;//0x28
		_WinRTpp01[ 5].value = Length;//no. of bytes to be read
		_WinRTpp01[ 6].port = Length;//no. of bytes to be read
		_WinRTpp01[ 6].value |= ((WINRT_TRACE_INFORMATIONAL)<<16);
		MEMCPY(&_WinRTpp01[ 7].command, "Read: Set DMA transfer length 0x%X\n", 36);
		_WinRTpp01[10].port = Address;
		_WinRTpp01[10].value |= ((WINRT_TRACE_INFORMATIONAL)<<16);
		MEMCPY(&_WinRTpp01[11].command, "Read: Set DMA transfer address 0x%X\n", 37);
		_WinRTpp01[15].port = AMCC5933BusMasterControlStatus;//0x3c
		_WinRTpp01[20].value |= ((WINRT_TRACE_INFORMATIONAL)<<16);
		MEMCPY(&_WinRTpp01[21].command, "Read: Start DMA transfer, Wrote MCSR 0x%X\n", 51);
		_WinRTpp01[27].port = AMCC5933BusMasterControlStatus;//0x3c
		if (!WinRTProcessIoBufferDirect(hWinRTBuff, _WinRTpp01,sizeof(_WinRTpp01), &iWinRTlength))
			goto dmaReadFifoError;

	}

	//debug message
	//MainForm->LabelMessage->Caption= "BufferReadFifo() Complete, transferred "
	//                             + IntToStr(Length) + "bytes";
	return (ERROR_SUCCESS);

	dmaReadFifoError:                       // For errors
	Error = GetLastError();
	theApp.dlg->LabelError.SetWindowText("BufferReadFifo() failed "+Error);
	return (Error);
}
/*------------------------------------------------------------------------*/
void CBufferThread::WriteToCard(int WriteSize, bool StreamSelectA)
{	
	if(!Terminated)
	{
		DWORD WaitTimeout;
		DWORD TempData=0;
		int FifoBytes;
		CString buffer;
		if(StreamSelectA)
		{
			theApp.dlg->gCommand2|=STRA_DATA_REQ|REP_XFIFO_REQ;
			CopyMemory( DmaBufferInfo.pVirtualAddress,&DataBuffer1,WriteSize);
		}
		else
		{
			theApp.dlg->gCommand2|=STRB_DATA_REQ|REP_XFIFO_REQ;
			CopyMemory( DmaBufferInfo.pVirtualAddress,&DataBuffer2,WriteSize);
		}
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);

		ResetEvent(hDMAReadCompleteEvent);
		DmaWriteFifo(WriteSize);
		WaitTimeout=WaitForSingleObject(hDMAReadCompleteEvent,5000);
		if(WaitTimeout == WAIT_TIMEOUT)
		{
			buffer.Format(_T("Buffer:WaitForDMAReadComplete failed, timeout %d"), WaitTimeout);
			theApp.dlg->LabelError.SetWindowText(buffer);
			//Application->ProcessMessages();
		}
		ResetEvent(hDMAReadCompleteEvent);


		if(StreamSelectA)
			theApp.dlg->gCommand2&=~STRA_DATA_REQ;
		else
			theApp.dlg->gCommand2 &=~STRB_DATA_REQ;

		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		theApp.dlg->gCommand2&=~REP_XFIFO_REQ;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
	}
}
/*------------------------------------------------------------------------*/
/////////////////////////////////////////////////////////////////////
//  DmaWriteFifo - sets up write DMA process,
//  Inputs: Length - Dma write  length (bytes)
//  Outputs:
//  Notes:
//////////////////////////////////////////////////////////////////////
DWORD CBufferThread::DmaWriteFifo(DWORD Length)
{
	DWORD       Error=0;                  // error return value
	DWORD       Address=0;                // address of WinRT common buffer (logical address)
	DWORD       iWinRTlength=0;           // length from the driver
	CString		buffer;


	if((Length < 4) || (Length > DmaBufferInfo.Length)) // check for valid length
	{
		buffer.Format(_T("DmaWriteFifo: Invalid Length %d valid range 4-%d"),
						  Length,
						  DmaBufferInfo.Length
						  );
		theApp.dlg->LabelError.SetWindowText(buffer);

		return (ERROR_INVALID_DATA);
	}


	if (Length & 0x3) // check that length can be converted into ULONG count
	{
		theApp.dlg->LabelError.SetWindowText("DmaWriteFifo: Invalid Length,  must be on a DWORD boundary");
		return (ERROR_INVALID_DATA);
	}
	// setup data in common buffer for write DMA

	Address = (DWORD)(DmaBufferInfo.LogicalAddress); //} get common buffer
													//} address for DMA (logical)

	//WinRT structure- set up MCSR and buffer
	static WINRT_CONTROL_ITEM _WinRTpp02[] =
		{//	command	param1	param2
			{DIM,	0x00040001,	 0x0},	// L:0 DmaMask
			{DIM,	0x00040001,	 0x0},	// L:1 StartDMA
			{DIM,	0x00040001,	 0x0},	// L:2 DmaControl
			{DIM,	0x00040001,	 0x0},	// L:3 Temp
			{OUTP_L,	0,	0},
			{OUTP_L,	0,	0},
			{WINRT_TRACE,	0x00000000,	0x00000025},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{WINRT_TRACE,	0x00000000,	0x00000026},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{INP_L,	0,	0},
			{MATH,	0x000D0002,	0x00024000},
			{MATH,	0x00080003,	0x00020000},
			{MATH,	0x00090002,	0x00030001},
			{MATH,	0x000D0002,	0x00021000},
			{WINRT_TRACE,	0x00000000,	0x00000035},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{NOP,	 0x0,	 0x0},
			{MATH,	0x000D0002,	0x00022000},
			{OUTP_L,	0,	0},
		};
		_WinRTpp02[ 0].value = (ULONG)S5933_MCSR_DMA_MASK;//0x0000FF00
		_WinRTpp02[ 1].value = (ULONG)S5933_MCSR_READ_TRANSFER_ENABLE;//(1<<14)
		_WinRTpp02[ 4].port = AMCC5933MasterReadAddress;
		_WinRTpp02[ 4].value = Address;
		_WinRTpp02[ 5].port = AMCC5933MasterReadTransferCount;
		_WinRTpp02[ 5].value = Length;
		_WinRTpp02[ 6].port = Length;
		_WinRTpp02[ 6].value |= ((WINRT_TRACE_INFORMATIONAL )<<16);
		MEMCPY(&_WinRTpp02[ 7].command, "Write: Set DMA transfer length 0x%X\n", 37);
		_WinRTpp02[11].port = Address;
		_WinRTpp02[11].value |= ((WINRT_TRACE_INFORMATIONAL)<<16);
		MEMCPY(&_WinRTpp02[12].command, "Write: Set DMA transfer address 0x%X\n", 38);
		_WinRTpp02[16].port = AMCC5933BusMasterControlStatus;
		_WinRTpp02[21].value |= ((WINRT_TRACE_INFORMATIONAL)<<16);
		MEMCPY(&_WinRTpp02[22].command, "Write: Start DMA Transfer, Wrote MCSR 0x%X\n", 53);
		_WinRTpp02[28].port = AMCC5933BusMasterControlStatus;
		if (!WinRTProcessIoBufferDirect(hWinRTBuff, _WinRTpp02,sizeof(_WinRTpp02), &iWinRTlength))
			goto dmaWriteFifoError;
	//debug message
	//MainForm->LabelMessage->Caption= "BufferWriteFifo() Complete, transferred "
	//                             + IntToStr(Length) + "bytes";

	return (ERROR_SUCCESS);

dmaWriteFifoError:
	Error = GetLastError();
	theApp.dlg->LabelError.SetWindowText("DmaWriteFifo() failed "
									+ Error);
	return (Error);
}
//--------------------------------------------------------------------------
void CBufferThread::DiskReadA(PUCHAR pBuffer1,int length)
{
	DWORD numBytesRead;
	bool bResult;
	if(theApp.hf_strA!=NULL)
	{
		bResult = ReadFile(theApp.hf_strA, (LPVOID)pBuffer1, length, &numBytesRead, NULL);
		if(bResult && numBytesRead == 0)
		{
			theApp.hf_strA = theApp.hf_strAstart;
			Beep(500, 50);
		}
	}

/*MainForm->PlayFileStreamA->Read((PUCHAR)pBuffer1,length);
if(MainForm->PlayFileStreamA->Position>=MainForm->PlayFileSizeA)
  {
  MainForm->PlayFileStreamA->Seek(1024,soFromBeginning);  //recirculates
  Beep(500,50);
  }*/
}
//--------------------------------------------------------------------------
void CBufferThread::DiskReadB(PUCHAR pBuffer2,int length)
{
	DWORD numBytesRead;
	bool bResult;
	if(theApp.hf_strB!=NULL)
	{
		bResult = ReadFile(theApp.hf_strB, (LPVOID)pBuffer2, length, &numBytesRead, NULL);
		if(bResult && numBytesRead == 0)
		{
			theApp.hf_strB = theApp.hf_strBstart;
			Beep(500, 50);
		}
	}
/*MainForm->PlayFileStreamB->Read((PUCHAR)pBuffer2,length);
if(MainForm->PlayFileStreamB->Position>=MainForm->PlayFileSizeB)
  {
  MainForm->PlayFileStreamB->Seek(1024,soFromBeginning);  //recirculates
  Beep(500,50);
  }*/
}
/*------------------------------------------------------------------------*/
void CBufferThread::DiskWriteA(PUCHAR pBuffer1,int length)
{
	CString buffer;

	theApp.strA.Write(pBuffer1, length);
	buffer.Format(_T("%d"), theApp.strA.GetPosition());
	theApp.dlg->LabelMessage.SetWindowText(buffer);
	/*
	MainForm->RecFileStreamA->Write((PUCHAR)pBuffer1,length);
	MainForm->LabelMessage->Caption=IntToStr(MainForm->RecFileStreamA->Position);
	*/
}
//--------------------------------------------------------------------------
void CBufferThread::DiskWriteB(PUCHAR pBuffer2,int length)
{
	CString buffer;

	theApp.strB.Write(pBuffer2, length);
	buffer.Format(_T("%d"), theApp.strB.GetPosition());
	theApp.dlg->LabelMessage.SetWindowText(buffer);
	/*
	MainForm->RecFileStreamB->Write((PUCHAR)pBuffer2,length);
	MainForm->LabelMessage->Caption=IntToStr(MainForm->RecFileStreamB->Position);
	*/
}
//---------------------------------------------------------------
 void CBufferThread::header_write_end1 (CFile *file)
{
	//writes end of file time and last byte (cursor) position starting at byte 96
	__int64 last_byte1; //was unsigned long
	char idle_code_mask=0x55;
	unsigned int rec_file_status1=0;
	SYSTEMTIME st;
	FILETIME filtim1;
	int HeaderPos=32;
	short signalling_timeslot1=16;
	rec_file_status1=rec_file_status1 | REC_MASK_BIT| REC_FRAME_BIT| REC_DUAL_BIT;

	file->Seek(HeaderPos, CFile::begin);
	file->Write((char*)&rec_file_status1,sizeof(rec_file_status1));
	file->Write((char*)&signalling_timeslot1,sizeof(signalling_timeslot1));
	file->Write((char*)&idle_code_mask,sizeof(idle_code_mask));
	
	/*
	Stream->Seek(HeaderPos,soFromBeginning);
	Stream->Write((char*)&rec_file_status1,sizeof(rec_file_status1));
	Stream->Write((char*)&signalling_timeslot1,sizeof(signalling_timeslot1));
	Stream->Write((char*)&idle_code_mask,sizeof(idle_code_mask));
	*/

	HeaderPos=96;
	GetLocalTime(&st);//write file stop time at pos 96
	SystemTimeToFileTime(&st,&filtim1);
	last_byte1=file->Seek(0,CFile::current);
	file->Seek(HeaderPos,CFile::begin);
	file->Write((char*)&filtim1,sizeof(FILETIME));
	file->Write((char*)&last_byte1,sizeof(last_byte1));
}
//-----------------------------------------------------------------------
void CBufferThread::Terminate()
{
	Terminated = true;
	/*DWORD WaitResult = WaitForSingleObject(TerminateEvent, 6000);
	if(WaitResult == WAIT_TIMEOUT)
		theApp.dlg->LabelMessage.SetWindowText("buffer thread");*/
}
//---------------------------------------------------------------------------------
int CBufferThread::GetBytesRem(short Stream)
{  //0 = Xfifo, 1 = str A, 2= str b
DWORD WordsRem=0;
DWORD WriteData=0;
int BytesRem;
int Ret;

switch(Stream){
	case 0: WriteData=STATUS_REQUEST|STATUS_B|OFFSET_0;
	break;
	case 1:	WriteData=STATUS_REQUEST|STATUS_B|OFFSET_1;
	break;
	case 2: WriteData=STATUS_REQUEST|STATUS_B|OFFSET_2;
	break;
	}
Ret=WriteMailBox1(OMB1, WriteData);
if(Ret==ERROR_SUCCESS)
		ReadMailBox1(IMB2,&WordsRem);
else
		WordsRem=0;
switch(Stream){
	case 0:
	BytesRem=(WordsRem & XFIFO_WORDS_MASK)*4;
	break;
	case 1:
	BytesRem=(WordsRem & WORDS_REMAIN_MASK)*4;
	break;
	case 2:
	BytesRem=(WordsRem & WORDS_REMAIN_MASK)*4;
	break;
	}
if(BytesRem==0)
  {
  int tmp=0;
  }
return(BytesRem);
}
//------------------------------------------------------------------------------
