//---------------------------------------------------------------------------

#ifndef R2D3AmccH
#define R2D3AmccH
//---------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////////
// Amcc.h Include file for AMCC 5935/3 
//
//  
//
//
//
//////////////////////////////////////////////////////////////////////////////


#include <windows.h>
#include <stdio.h>
#include <conio.h>


    // address definitions
#define PASSTHRU_ADDRESS    (AmccAddress.PassThruMin + Address)
#define OUT_MAILBOX_ADDRESS (AmccAddress.OperationMin + ((Address - 1) * sizeof(DWORD)))
#define IN_MAILBOX_ADDRESS  (AmccAddress.OperationMin + AMCC5933IncomingMailbox1 + \
                                        ((Address - 1) * sizeof(DWORD)))
                            //AMCC5933IncomingMailbox =0x10
    // lowest legal mailbox number
#define AMCC_MINIMUM_MAILBOX    1
#define AMCC_MAXIMUM_MAILBOX    4

#define AMCCERRORINTERRUPT         0
#define AMCCDMAWRITEINTERRUPT      1
#define AMCCDMAREADINTERRUPT       2
#define AMCCMAILBOXREADINTERRUPT   3
#define AMCCMAILBOXWRITEINTERRUPT  4
#define MAX_EVENTS                 5

typedef struct _AMCC_ADDRESS
{
    ULONG   OperationMin;   // Amcc5933 Operation registers (Start address)
    ULONG   OperationMax;   // Amcc5933 Operation registers (End address)
    ULONG   PassThruMin;    // Amcc5933 Pass Thru registers (Start address)
    ULONG   PassThruMax;    // Amcc5933 Pass Thru registers (End address)
} AMCC_ADDRESS, *PAMCC_ADDRESS;


typedef struct _AMCC_REGISTERS
{
    ULONG   OutgoingMailbox1;        // OMB1 -- Outgoing mailbox register 1
    ULONG   OutgoingMailbox2;        // OMB2 -- Outgoing mailbox register 2
    ULONG   OutgoingMailbox3;        // OMB3 -- Outgoing mailbox register 3
    ULONG   OutgoingMailbox4;        // OMB4 -- Outgoing mailbox register 4
    ULONG   IncomingMailbox1;        // IMB1 -- Incoming mailbox register 1
    ULONG   IncomingMailbox2;        // IMB2 -- Incoming mailbox register 2
    ULONG   IncomingMailbox3;        // IMB3 -- Incoming mailbox register 3
    ULONG   IncomingMailbox4;        // IMB4 -- Incoming mailbox register 4
    ULONG   FIFORegisterPort;        // FIFO -- FIFO register port
    ULONG   MasterWriteAddress;      // MWAR -- Master write address register
    ULONG   MasterWriteTransferCount;// MWTC -- Master write transfer count
                                     //         register
    ULONG   MasterReadAddress;       // MRAR -- Master read address register
    ULONG   MasterReadTransferCount; // MRTC -- Master read transfer count
                                     //         register
    ULONG   MailboxStatus;           // MBEF -- Mailbox Empty/Full Status
                                     //         register
    ULONG   InterruptControlStatus;  // INTCSR -- Interrupt Control/Status
                                     //         register
    ULONG   BusMasterControlStatus;  // MCSR -- Bus master control/status
                                     //         register
} AMCC_REGISTERS, *PAMCC_REGISTERS;


//#define     SCREEN_WIDTH        80  // Screen width, for text formatting


    // function prototypes
DWORD OpenPciAmcc(void);
DWORD ClosePciAmcc(void);
DWORD ResetAmcc(void);
DWORD DisableAmccInterrupts(void);
DWORD EnableAmccInterrupts(DWORD InterruptEnable);
VOID  StopInterrupt(void);
VOID  RejectInterrupt(void);
BOOLEAN SetUpAmccIsr(void);
DWORD ReadMailBox1(DWORD Address,DWORD *pMailboxData);//w/o interrupt
DWORD WriteMailBox1(DWORD Address, DWORD Data);
DWORD ResetAmccFifo(void);

#endif
