// R2D3Record.cpp : Defines the class behaviors for the application.
//

/*-Includes-----------------------------------------------------------------*/
#include "stdafx.h"
#include "R2D3Record.h"
#include "R2D3RecordDlg.h"
#include ".\R2D3Record.h"
#include "r2d3DABctl.h"
#include "StatusThread.h"
#include "amcc5933.h"
#include "BufferThread.h"
#include "InterruptThread.h"
#include "resource.h"

/*-Defines------------------------------------------------------------------*/
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-Globals------------------------------------------------------------------*/
CR2D3RecordApp theApp; // The one and only CR2D3RecordApp object
extern DWORD gStatusRegister[];
extern CBufferThread *pBufferThread;
extern CInterruptThread *pInterruptThread;
extern HANDLE hDMAReadCompleteEvent;
extern HANDLE hHiThreshIntEvent;
extern HANDLE hBufferGoEvent;
extern HANDLE BufferThreadFinishedEvent;

/*--------------------------------------------------------------------------*/
// CR2D3RecordApp
BEGIN_MESSAGE_MAP(CR2D3RecordApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_COMMAND(ID_CONTROL, OnControl)
	ON_COMMAND(ID_STATUS, OnStatus)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_WRITE, OnWrite)
//	ON_COMMAND(ID_STRA, OnStra)
//	ON_COMMAND(ID_STRB, OnStrb)
END_MESSAGE_MAP()


/*-Methods------------------------------------------------------------------*/

// CR2D3RecordApp construction
CR2D3RecordApp::CR2D3RecordApp()
{
	hf_strA = NULL;
	hf_strB = NULL;
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
/*--------------------------------------------------------------------------*/

// CR2D3RecordApp initialization
BOOL CR2D3RecordApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views

	dlg = new CR2D3RecordDlg;
	m_pMainWnd = dlg;
	dlg->Create(IDD_R2D3RECORD_DIALOG, 0);
	dlg->ShowWindow(SW_SHOW);
	
	ctrlDlg = new CControlDlg(NULL);	//} Create the control dialog
	ctrlDlg->Create(IDD_CONTROLS, 0);	//}

	statDlg = new CStatusDlg(NULL);		//} Create the status dialog
	statDlg->Create(IDD_STATUS, 0);		//}

	AboutDlg = new CSDAboutDlg(NULL);
	AboutDlg->Create(IDD_ABOUT, 0);

	return TRUE;
}
/*--------------------------------------------------------------------------*/

void CR2D3RecordApp::OnControl()
{
	ctrlDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/

void CR2D3RecordApp::OnStatus()
{
	statDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/
void CR2D3RecordApp::OnAbout()
{
int CardType=0;
unsigned int CardSerNum=0;
CString buffer;
//CardSerNum=(gStatusRegister[9]& SER_NUM_UPR_MASK)<<28;
CardSerNum|=gStatusRegister[8] & SER_NUM_LWR_MASK;
buffer.Format(_T("%x"), CardSerNum);
//buffer.Format(_T("%d.%d"), CardType, CardSerNum);
AboutDlg->CardNo.SetWindowText(buffer);
AboutDlg->ShowWindow(SW_SHOW);
}
//-------------------------------------------------------------------------------------------------
void CR2D3RecordApp::OnWrite()
{
	int PBufPage;
//	DWORD Wait;
	
	CMenu menu;
	menu.LoadMenu(IDR_MENU1);

	theApp.dlg->Write = !theApp.dlg->Write;
	
	if(theApp.dlg->Write)
	{
		
		pBufferThread = new CBufferThread();

		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_WRITE, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);
	
		char* pszFileName = ".\\StreamA.r2d";
		
		CFileException fileException;

		if ( !strA.Open( pszFileName, CFile::modeCreate |   
				CFile::modeReadWrite, &fileException ) )
		{
			TRACE( "Can't open file %s, error = %u\n",
			pszFileName, fileException.m_cause );
		}

		pszFileName = ".\\StreamB.r2d";
		if ( !strB.Open( pszFileName, CFile::modeCreate |   
				CFile::modeReadWrite, &fileException ) )
		{
			TRACE( "Can't open file %s, error = %u\n",
			pszFileName, fileException.m_cause );
		}
		
		/*RecFileNameA=ExtractFilePath(Application->ExeName)+ RecordFileNameA;
		RecFileStreamA = new TFileStream(RecFileNameA, fmCreate);//always overwrite
		RecFileNameB=ExtractFilePath(Application->ExeName)+ RecordFileNameB;
		RecFileStreamB = new TFileStream(RecFileNameB, fmCreate);//always overwrite*/
			
		theApp.dlg->gCommand2&=~STRA_START&~STRB_START;			// stop card
		theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET; // reset main memory buffers
		theApp.dlg->gCommand2|=STRA_RECORD|STRB_RECORD;			// record mode
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);				// send commands

		theApp.dlg->gCommand2|=XFIFO_RESET;						// reset cache fifo
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);


		theApp.dlg->gCommand1|=INT_EN_THRESH_STRA;				//} Set up
		theApp.dlg->gCommand1|=INT_EN_THRESH_STRB;				//} card
		theApp.dlg->gCommand1|=INT_EN_THRESH_HI|INT_EN_COMMAND;	//}	interrupts
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);

		theApp.dlg->gCommand1&=~INT_EN_COMMAND;					//} Disable card interrupts
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);				//} to confirm interrupt selection


		// Set up AMCC interrupt control status register
		theApp.dlg->gInterruptCommand|= S5933_INTCSR_WRITE_INTERRUPT; // Dma transfer
		theApp.dlg->gInterruptCommand|=S5933_INTCSR_IN_MAILBOX_4|S5933_INTCSR_IN_BYTE_4|S5933_INTCSR_INCOMING_INTERRUPT;
		EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		theApp.dlg->gCommand2&=~STRA_FIFO_RESET;//&~STRA_UNFRAMED;
		theApp.dlg->gCommand2&=~STRB_FIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		theApp.dlg->gCommand2&=~XFIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
	
		ResetEvent(hHiThreshIntEvent);//initial condition

		header_write1(&strA);
		header_write1(&strB);

		//set card to active, allow replay to start
		
		theApp.dlg->gCommand2|=STRA_START;
		theApp.dlg->gCommand2|= STRB_START;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		
		//pBufferThread = new CBufferThread();
		
		SetEvent(hBufferGoEvent);
		//  pStatusDisplayThread->Resume();

	}
	else
	{
		//  DiskReadBtn->Caption="Play Disk";
		//stop buffer thread
		//theApp.dlg->Read = false;
		pBufferThread->Terminate();
//		DWORD res = WaitForSingleObject(BufferThreadFinishedEvent, INFINITE);
		//pBufferThread->Terminate();
		//pInterruptThread->Terminate();

		//delete pBufferThread;
		//delete pInterruptThread;

//		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_GRAYED);
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);
		ResetEvent(hBufferGoEvent);
		//close file
		//stop interrupts
		theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_WRITE_INTERRUPT;
		theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_INCOMING_INTERRUPT;
		EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		theApp.dlg->gCommand1=0;
		theApp.dlg->gCommand1|=INT_EN_COMMAND;
		theApp.dlg->gCommand1&=~INT_EN_THRESH_HI&~INT_EN_THRESH_STRA&~INT_EN_THRESH_STRB;//&~STRA_DATA_REQ ;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		theApp.dlg->gCommand1&=~INT_EN_COMMAND;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);

		theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
		theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//Write1->Enabled =true;
		SetEvent(hHiThreshIntEvent);//frees waiting thread
		//StreamAEnabled = false;
		//StreamBEnabled = false;

	}

}
//---------------------------------------------------------------------------
void CR2D3RecordApp::header_write1(CFile *file)
{
	//header consists of record status(32bytes),start time, & cursor position 4 bytes
	//contains information to ensure compatibility with R2D files
	int n;
	SYSTEMTIME st;
	FILETIME filtim1;
	short RecordStatus=1;
	unsigned char Space=0x20;
	int HeaderPos=0;
	file->Seek(HeaderPos,CFile::begin);
	for(n=0;n<32;n++)//force record status to be all ones
		file->Write(&RecordStatus,1);
	for(n=0;n<32;n++)
		file->Write(&Space,1);
	GetLocalTime(&st);//write file start time at pos 64
	SystemTimeToFileTime(&st,&filtim1);
	file->Write((char*)&filtim1,sizeof(FILETIME));
	HeaderPos=file->Seek(0,CFile::current);
	for (n=HeaderPos;n<1024;n++)
		file->Write(&Space,1);
}
/*
void CR2D3RecordApp::OnStra()
{
	OPENFILENAME openfilename;	// open dialog box struct
	char szFile[260];			// buffer for file name
	//HANDLE hf;					// file handle

	ZeroMemory(&openfilename, sizeof(openfilename));
	openfilename.lStructSize		= sizeof(openfilename);
	openfilename.hwndOwner			= NULL;
	openfilename.hInstance			= NULL;
	openfilename.lpstrFilter		= "R2D Files\0*.r2d;*.R2D\0";
	openfilename.nFilterIndex		= 1;
	openfilename.lpstrFile			= szFile;
	openfilename.lpstrFile[0]		= '\0';
	openfilename.nMaxFile			= sizeof(szFile);
	openfilename.lpstrFileTitle		= NULL;
	openfilename.nMaxFileTitle		= 0;
	openfilename.lpstrInitialDir	= NULL;
	openfilename.Flags				= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if(GetOpenFileName(&openfilename))
	{
		StreamAEnabled = true;
		CMenu menu;
		menu.LoadMenu(IDR_MENU1);
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
//		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);

		hf_strA = CreateFile(openfilename.lpstrFile,
						GENERIC_READ,
						0,
						(LPSECURITY_ATTRIBUTES) NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						(HANDLE) NULL);
		hf_strAstart = hf_strA;

		PlayFileSizeA = GetFileSize(hf_strA, NULL);
	}
		

}

void CR2D3RecordApp::OnStrb()
{
	OPENFILENAME openfilename;	// open dialog box struct
	char szFile[260];			// buffer for file name
	//HANDLE hf;					// file handle

	ZeroMemory(&openfilename, sizeof(openfilename));
	openfilename.lStructSize		= sizeof(openfilename);
	openfilename.hwndOwner			= NULL;
	openfilename.hInstance			= NULL;
	openfilename.lpstrFilter		= "R2D Files\0*.r2d;*.R2D\0";
	openfilename.nFilterIndex		= 1;
	openfilename.lpstrFile			= szFile;
	openfilename.lpstrFile[0]		= '\0';
	openfilename.nMaxFile			= sizeof(szFile);
	openfilename.lpstrFileTitle		= NULL;
	openfilename.nMaxFileTitle		= 0;
	openfilename.lpstrInitialDir	= NULL;
	openfilename.Flags				= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if(GetOpenFileName(&openfilename))
	{
		StreamBEnabled = true;

		CMenu menu;
		menu.LoadMenu(IDR_MENU1);
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
//		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);

		hf_strB = CreateFile(openfilename.lpstrFile,
						GENERIC_READ,
						0,
						(LPSECURITY_ATTRIBUTES) NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						(HANDLE) NULL);
		hf_strBstart = hf_strB;

		PlayFileSizeB = GetFileSize(hf_strB, NULL);
	}
}
*/