// R2D3Replay.cpp : Defines the class behaviors for the application.
//
/*
Copyright Somerdata Ltd 2008.
Used to demonstrate replaying of data from files using the R2D31 series of data
data capture cards. Built using Visual Studio 2008 MFC Visual C++.
This sample code is provided for developers and demonstration
purposes and comes without warranty or support.
The code  is deliberately simplified without error checking or 
exception handling to show the basics of programming for the card.
The application is multi-threaded with separate threads for interrupt servicing 
and status gathering routines. Thread safety is not guaranteed, since
synchronisation code has been removed to provide clarity of use. 
See the Somerdata Developer's kit documentation for more information.
*/

/*-Includes-----------------------------------------------------------------*/
#include "stdafx.h"
#include "R2D3Replay.h"
#include "R2D3ReplayDlg.h"
#include ".\R2D3Replay.h"
#include "r2d3DABctl.h"
#include "StatusThread.h"
#include "amcc5933.h"
#include "BufferThread.h"
#include "InterruptThread.h"
#include "resource.h"

/*-Defines------------------------------------------------------------------*/
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-Globals------------------------------------------------------------------*/
CR2D3ReplayApp theApp; // The one and only CR2D3ReplayApp object
extern DWORD gStatusRegister[9];
extern CBufferThread *pBufferThread;
extern CInterruptThread *pInterruptThread;
extern HANDLE hDMAReadCompleteEvent;
extern HANDLE hHiThreshIntEvent;
extern HANDLE hBufferGoEvent;
extern HANDLE BufferThreadFinishedEvent;

/*--------------------------------------------------------------------------*/
// CR2D3ReplayApp
BEGIN_MESSAGE_MAP(CR2D3ReplayApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_COMMAND(ID_CONTROL, OnControl)
	ON_COMMAND(ID_STATUS, OnStatus)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_READ, OnRead)
	ON_COMMAND(ID_STRA, OnStra)
	ON_COMMAND(ID_STRB, OnStrb)
END_MESSAGE_MAP()


/*-Methods------------------------------------------------------------------*/

// CR2D3ReplayApp construction
CR2D3ReplayApp::CR2D3ReplayApp()
{
	hf_strA = NULL;
	hf_strB = NULL;
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
/*--------------------------------------------------------------------------*/

// CR2D3ReplayApp initialization
BOOL CR2D3ReplayApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views

	dlg = new CR2D3ReplayDlg;
	m_pMainWnd = dlg;
	dlg->Create(IDD_R2D3REPLAY_DIALOG, 0);
	dlg->ShowWindow(SW_SHOW);
	
	ctrlDlg = new CControlDlg(NULL);	//} Create the control dialog
	ctrlDlg->Create(IDD_CONTROLS, 0);	//}

	statDlg = new CStatusDlg(NULL);		//} Create the status dialog
	statDlg->Create(IDD_STATUS, 0);		//}

	AboutDlg = new CSDAboutDlg(NULL);
	AboutDlg->Create(IDD_ABOUT, 0);

	return TRUE;
}
/*--------------------------------------------------------------------------*/

void CR2D3ReplayApp::OnControl()
{
	ctrlDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/

void CR2D3ReplayApp::OnStatus()
{
	statDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/
void CR2D3ReplayApp::OnAbout()
{
int CardType=0;
unsigned int CardSerNum=0;
CString buffer;
//CardSerNum=(gStatusRegister[9]& SER_NUM_UPR_MASK)<<28;
CardSerNum|=gStatusRegister[8] & SER_NUM_LWR_MASK;
buffer.Format(_T("%x"), CardSerNum);
//buffer.Format(_T("%d.%d"), CardType, CardSerNum);
AboutDlg->CardNo.SetWindowText(buffer);
AboutDlg->ShowWindow(SW_SHOW);
}
//---------------------------------------------------------------------
void CR2D3ReplayApp::OnRead()
{
	int PBufPage;
//	DWORD Wait;
	
	CMenu menu;
	menu.LoadMenu(IDR_MENU1);

	/*UINT state = menu.GetMenuState(ID_READ, MF_BYCOMMAND);
	if (state & MF_CHECKED)
		menu.CheckMenuItem(ID_READ, MF_UNCHECKED | MF_BYCOMMAND);
	else
		menu.CheckMenuItem(ID_READ, MF_CHECKED | MF_BYCOMMAND);
	state = menu.GetMenuState(ID_READ, MF_BYCOMMAND);
	//Read1->Checked=!Read1->Checked;
	bool res = SetMenu(theApp.GetMainWnd()->GetSafeHwnd(), menu.GetSafeHmenu());
	*/
	theApp.dlg->Read = !theApp.dlg->Read;
	

	if(theApp.dlg->Read)
	{

		//delete pBufferThread;
		//delete pInterruptThread;
		//pBufferThread = new CBufferThread();
		//pInterruptThread = new CInterruptThread();
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);
		
		theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
		theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
		theApp.dlg->gCommand2|=XFIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);


		theApp.dlg->gCommand1|=INT_EN_THRESH_STRA;
		theApp.dlg->gCommand1|=INT_EN_THRESH_STRB;
		theApp.dlg->gCommand1|=INT_EN_THRESH_HI|INT_EN_COMMAND;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		theApp.dlg->gCommand1&=~INT_EN_COMMAND;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);


		theApp.dlg->gInterruptCommand|= S5933_INTCSR_READ_INTERRUPT;//dma	transfer
		EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		theApp.dlg->gCommand2&=~STRA_RECORD&~STRA_FIFO_RESET;//&~STRA_UNFRAMED;
		theApp.dlg->gCommand2&=~STRB_RECORD&~STRB_FIFO_RESET;
		theApp.dlg->gCommand2&=~XFIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
	
		PBufPage=R2D3_BUF_SIZE/(pBufferThread->NumBytes);// fill

		//theApp.dlg->gCommand2|=STRA_DATA_REQ|REP_XFIFO_REQ;
		//WriteMailBox1(OMB2, theApp.dlg->gCommand2);

		if(StreamAEnabled)
		{
			for(int n=0;n<PBufPage;n++)
			{
				pBufferThread->DiskReadA( pBufferThread->DataBuffer1,pBufferThread->NumBytes);
				pBufferThread-> WriteToCard(pBufferThread->NumBytes,true);//stream A =true
			}
		}
		if(StreamBEnabled)
		{
			for(int nn=0;nn<PBufPage;nn++)
			{
				pBufferThread->DiskReadB(pBufferThread->DataBuffer2,pBufferThread->NumBytes);
				pBufferThread->WriteToCard(pBufferThread->NumBytes,false);
			}
		}

		theApp.dlg->gInterruptCommand|=S5933_INTCSR_IN_MAILBOX_4|S5933_INTCSR_IN_BYTE_4|S5933_INTCSR_INCOMING_INTERRUPT;
		EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		ResetEvent(hHiThreshIntEvent);//initial condition
		//set card to active, allow replay to start
		if(StreamAEnabled)
			theApp.dlg->gCommand2|=STRA_START;
		if(StreamBEnabled)
			theApp.dlg->gCommand2|= STRB_START;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//theApp.dlg->Read = true;
		
		SetEvent(hBufferGoEvent);
		//  pStatusDisplayThread->Resume();

	}
	else
	{
		//  DiskReadBtn->Caption="Play Disk";
		//stop buffer thread
		//theApp.dlg->Read = false;

		//pBufferThread->Terminate();
		//pInterruptThread->Terminate();

		//delete pBufferThread;
		//delete pInterruptThread;

		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_GRAYED);
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);
		DWORD res = WaitForSingleObject(BufferThreadFinishedEvent, 6000);
		ResetEvent(hBufferGoEvent);
		//close file
		//stop interrupts
		theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_READ_INTERRUPT;
		theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_INCOMING_INTERRUPT;
		EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		theApp.dlg->gCommand1=0;
		theApp.dlg->gCommand1|=INT_EN_COMMAND;
		theApp.dlg->gCommand1&=~INT_EN_THRESH_HI&~INT_EN_THRESH_STRA&~INT_EN_THRESH_STRB;//&~STRA_DATA_REQ ;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		theApp.dlg->gCommand1&=~INT_EN_COMMAND;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);

		theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
		theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//Write1->Enabled =true;
		SetEvent(hHiThreshIntEvent);//frees waiting thread
		StreamAEnabled = false;
		StreamBEnabled = false;

	}

}

//---------------------------------------------------------------------
void CR2D3ReplayApp::OnStra()
{
	OPENFILENAME openfilename;	// open dialog box struct
	char szFile[260];			// buffer for file name
	//HANDLE hf;					// file handle

	ZeroMemory(&openfilename, sizeof(openfilename));
	openfilename.lStructSize		= sizeof(openfilename);
	openfilename.hwndOwner			= NULL;
	openfilename.hInstance			= NULL;
	openfilename.lpstrFilter		= "R2D Files\0*.r2d;*.R2D\0";
	openfilename.nFilterIndex		= 1;
	openfilename.lpstrFile			= szFile;
	openfilename.lpstrFile[0]		= '\0';
	openfilename.nMaxFile			= sizeof(szFile);
	openfilename.lpstrFileTitle		= NULL;
	openfilename.nMaxFileTitle		= 0;
	openfilename.lpstrInitialDir	= NULL;
	openfilename.Flags				= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if(GetOpenFileName(&openfilename))
	{
		StreamAEnabled = true;
		CMenu menu;
		menu.LoadMenu(IDR_MENU1);
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);

		hf_strA = CreateFile(openfilename.lpstrFile,
						GENERIC_READ,
						0,
						(LPSECURITY_ATTRIBUTES) NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						(HANDLE) NULL);
		hf_strAstart = hf_strA;

		PlayFileSizeA = GetFileSize(hf_strA, NULL);
	}
		

}

void CR2D3ReplayApp::OnStrb()
{
	OPENFILENAME openfilename;	// open dialog box struct
	char szFile[260];			// buffer for file name
	//HANDLE hf;					// file handle

	ZeroMemory(&openfilename, sizeof(openfilename));
	openfilename.lStructSize		= sizeof(openfilename);
	openfilename.hwndOwner			= NULL;
	openfilename.hInstance			= NULL;
	openfilename.lpstrFilter		= "R2D Files\0*.r2d;*.R2D\0";
	openfilename.nFilterIndex		= 1;
	openfilename.lpstrFile			= szFile;
	openfilename.lpstrFile[0]		= '\0';
	openfilename.nMaxFile			= sizeof(szFile);
	openfilename.lpstrFileTitle		= NULL;
	openfilename.nMaxFileTitle		= 0;
	openfilename.lpstrInitialDir	= NULL;
	openfilename.Flags				= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if(GetOpenFileName(&openfilename))
	{
		StreamBEnabled = true;

		CMenu menu;
		menu.LoadMenu(IDR_MENU1);
		menu.EnableMenuItem(ID_STATUS, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_CONTROL, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
		menu.EnableMenuItem(ID_READ, MF_BYCOMMAND | MF_ENABLED);
		theApp.dlg->MyEnableMenuItem(&menu);

		hf_strB = CreateFile(openfilename.lpstrFile,
						GENERIC_READ,
						0,
						(LPSECURITY_ATTRIBUTES) NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						(HANDLE) NULL);
		hf_strBstart = hf_strB;

		PlayFileSizeB = GetFileSize(hf_strB, NULL);
	}
}
