// R2D3ReplayDlg.cpp : implementation file
//
/*-Includes-----------------------------------------------------------------*/
#include "stdafx.h"
#include "R2D3Replay.h"
#include "R2D3ReplayDlg.h"
#include ".\R2D3Replaydlg.h"
#include "r2d3DABctl.h"
#include "interruptthread.h"
#include "bufferthread.h"

/*-Defines------------------------------------------------------------------*/
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-Globals------------------------------------------------------------------*/
HANDLE hStatus_Display_Event;
//extern bool Terminated;
HANDLE hDMAWriteCompleteEvent;
HANDLE hDMAReadCompleteEvent;
HANDLE hHiThreshIntEvent;
HANDLE hBufferGoEvent;
HANDLE hBufferEventA;
HANDLE hBufferEventB;
HANDLE hFinishedWithBufferDataB;
CRITICAL_SECTION  csStatusUpdate;

extern HANDLE BufferThreadFinishedEvent;
extern HANDLE InterruptThreadFinishedEvent;

CInterruptThread *pInterruptThread=NULL;
CBufferThread *pBufferThread=NULL;
CStatusThread *pStatusThread=NULL;

/*-CAboutDlg Class----------------------------------------------------------*/
// Used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

/*-CAboutDlg Methods--------------------------------------------------------*/
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}
/*--------------------------------------------------------------------------*/

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}
/*--------------------------------------------------------------------------*/

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()
/*--------------------------------------------------------------------------*/

/*-CR2D3ReplayDlg Message Map----------------------------------------------*/

BEGIN_MESSAGE_MAP(CR2D3ReplayDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_CLOSE()
	ON_BN_CLICKED(ID_BTNOPEN, OnBnClickedBtnopen)
END_MESSAGE_MAP()

/*-CR2D3ReplayDlg Methods--------------------------------------------------*/

CR2D3ReplayDlg::CR2D3ReplayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CR2D3ReplayDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	gCommand1,gCommand2,gCommand3,gCommand4 = 0;
	
	gInterruptCommand = 0;
	
	gStreamSelect = 0;
  isOpenCard=false;
	Read = false;

	//menu.LoadMenu(IDR_MENU1);
}
/*--------------------------------------------------------------------------*/

void CR2D3ReplayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_Control(pDX, IDC_LIST2, listBox2);
	//DDX_Control(pDX, IDC_LIST1, listBox1);
	DDX_Control(pDX, IDC_DISPLAY1, display1);
	DDX_Control(pDX, IDC_DISPLAY2, display2);

	DDX_Control(pDX, ID_BTNOPEN, OpenBtn);
	DDX_Control(pDX, IDC_ERROR, LabelError);
	DDX_Control(pDX, IDC_STATUS, StatusLabel);

	DDX_Control(pDX, IDC_MSG, LabelMessage);
}
/*--------------------------------------------------------------------------*/

// CR2D3ReplayDlg message handlers
BOOL CR2D3ReplayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}
/*--------------------------------------------------------------------------*/

void CR2D3ReplayDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
/*--------------------------------------------------------------------------*/

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CR2D3ReplayDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
/*--------------------------------------------------------------------------*/
// The system calls this function to obtain the cursor to 
// display while the user drags the minimized window.
HCURSOR CR2D3ReplayDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
/*--------------------------------------------------------------------------*/

void CR2D3ReplayDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}
/*--------------------------------------------------------------------------*/

void CR2D3ReplayDlg::OnClose()
{
	//Terminated = true;
	theApp.m_pMainWnd->DestroyWindow();
}
/*--------------------------------------------------------------------------*/
void CR2D3ReplayDlg::OnBnClickedBtnopen()
{
extern HANDLE AmccWin32InterruptEvents[];
	
CMenu menu;
menu.LoadMenu(IDR_MENU1);
//	static bool OpenCard;
isOpenCard=!isOpenCard;
if(isOpenCard)
	{
	hStatus_Display_Event = CreateEvent(NULL, true, false, NULL);
	hDMAWriteCompleteEvent = CreateEvent(NULL, true, false, NULL);
	hDMAReadCompleteEvent = CreateEvent(NULL, true, false, NULL);
	hBufferGoEvent= CreateEvent(NULL, true, false, NULL);
	hHiThreshIntEvent= CreateEvent(NULL, true, false, NULL);
	OpenPciAmcc();
	ResetAmcc();
	InitialiseCard();
	theApp.dlg->OpenBtn.SetWindowText("Close");
		
	int temp = menu.EnableMenuItem(ID_STATUS, MF_ENABLED);
	menu.EnableMenuItem(ID_CONTROL, MF_ENABLED);
	menu.EnableMenuItem(ID_ABOUT, MF_ENABLED);
	//menu.EnableMenuItem(ID_READ, MF_ENABLED);
	SetMenu(&menu);

	DriverOpen=true;

	pStatusThread=new CStatusThread();
	if(pInterruptThread==NULL)
  	pInterruptThread=new CInterruptThread();
		
		if(pBufferThread==NULL)
			pBufferThread=new CBufferThread();
	}
else
	{
  if(pBufferThread)
    pBufferThread->Terminate();
  SetEvent(hBufferGoEvent);//free waiting thread
  SetEvent(hHiThreshIntEvent);		
  pBufferThread=NULL;
	pStatusThread->Terminate();
	SetEvent(hStatus_Display_Event);
  pInterruptThread->Terminate();
	SetEvent(AmccWin32InterruptEvents[0]);
  pInterruptThread=NULL;
  ClosePciAmcc();	
	
	theApp.dlg->OpenBtn.SetWindowText("Open");
	CloseHandle(hDMAWriteCompleteEvent);
	CloseHandle(hDMAReadCompleteEvent);
	ResetEvent(hStatus_Display_Event);
	CloseHandle(hStatus_Display_Event);
	CloseHandle(hBufferEventA);
	CloseHandle(hBufferEventB);
	CloseHandle(hBufferGoEvent);
	CloseHandle(hHiThreshIntEvent);
	DeleteCriticalSection(&csStatusUpdate);

	menu.EnableMenuItem(ID_STATUS, MF_GRAYED);
	menu.EnableMenuItem(ID_CONTROL, MF_GRAYED);
	menu.EnableMenuItem(ID_ABOUT, MF_GRAYED);
		//menu.EnableMenuItem(ID_READ, MF_GRAYED);
	SetMenu(&menu);

//		theApp.dlg->listBox1.ResetContent();
//		theApp.dlg->listBox2.ResetContent();
	DriverOpen=false;
	}

}
//------------------------------------------------------------------------
void CR2D3ReplayDlg::InitialiseCard(void)
{
gCommand1=0;
gCommand2=0;
gCommand3=0;
gCommand4=0;
//general card setup
gCommand2|=AUTO_FRAME|STR_LOZ;;	//start in auto and terminated impedance
//Stream A setup
gCommand2&=~STRA_START&~STRA_INTCLK&~STRA_E2E&~STRA_OP_ZERO;
gCommand2|=STRA_FIFO_RESET;
WriteMailBox1(OMB2, gCommand2);
//Stream B setup	
gCommand2=0;
gCommand2&=~STRB_START&~STRB_INTCLK&~STRB_E2E&~STRB_OP_ZERO;
gCommand2|=STRB_FIFO_RESET;
WriteMailBox1(OMB2, gCommand2);

NMHDR Nmhdr;
LRESULT Result;
//Controls setup (match card settings above)
theApp.ctrlDlg->StrASliderLow.SetPos(31);
theApp.ctrlDlg->StrASliderHi.SetPos(32);
theApp.ctrlDlg->OnNMReleasedcaptureSlider2(&Nmhdr, &Result);
theApp.ctrlDlg->StrBSliderLow.SetPos(31);
theApp.ctrlDlg->StrBSliderHi.SetPos(32);
theApp.ctrlDlg->OnNMReleasedcaptureSlider4(&Nmhdr, &Result);
theApp.ctrlDlg->StrAImp2.SetCheck(BST_CHECKED);
theApp.ctrlDlg->OnBnClickedStrAImpMode();
theApp.ctrlDlg->StrAutoFrm.SetCheck(BST_CHECKED);
theApp.ctrlDlg->OnBnClickedStrAFramed();
}
//-------------------------------------------------------------------
void CR2D3ReplayDlg::MyEnableMenuItem(CMenu *menu)
{
	/*CMenu menu;
	menu.LoadMenu(IDR_MENU1);
	menu.EnableMenuItem(ID_STATUS, MF_ENABLED | MF_BYCOMMAND);
	menu.EnableMenuItem(ID_CONTROL, MF_ENABLED | MF_BYCOMMAND);
	menu.EnableMenuItem(ID_ABOUT, MF_ENABLED | MF_BYCOMMAND);
	menu.EnableMenuItem(ID_READ, MF_ENABLED | MF_BYCOMMAND);
	

	menu.EnableMenuItem(nIDEnableItem, nEnable);*/
	SetMenu(menu);
}
