// R2D3Interrupt.cpp : Defines the class behaviors for the application.
//

/*-Includes-----------------------------------------------------------------*/
#include "stdafx.h"
#include "R2D3Interrupt.h"
#include "R2D3InterruptDlg.h"
#include ".\r2d3interrupt.h"
#include "R2D3DABCtl.h"
#include "StatusThread.h"
#include "amcc5933.h"
#include "BufferThread.h"
#include "resource.h"

/*-Defines------------------------------------------------------------------*/
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-Globals------------------------------------------------------------------*/
CR2D3InterruptApp theApp; // The one and only CR2D3InterruptApp object
extern DWORD gStatusRegister[12];
extern CBufferThread *pBufferThread;
extern HANDLE hDMAReadCompleteEvent;
extern HANDLE hHiThreshIntEvent;
extern HANDLE hBufferGoEvent;
/*--------------------------------------------------------------------------*/
// CR2D3InterruptApp
BEGIN_MESSAGE_MAP(CR2D3InterruptApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_COMMAND(ID_CONTROL, OnControl)
	ON_COMMAND(ID_STATUS, OnStatus)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_READ, OnRead)
	ON_COMMAND(ID_WRITE, OnWrite)
END_MESSAGE_MAP()


/*-Methods------------------------------------------------------------------*/

// CR2D3InterruptApp construction
CR2D3InterruptApp::CR2D3InterruptApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
/*--------------------------------------------------------------------------*/

// CR2D3InterruptApp initialization
BOOL CR2D3InterruptApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	dlg = new CR2D3InterruptDlg;
	m_pMainWnd = dlg;
	dlg->Create(IDD_R2D3INTERRUPT_DIALOG, 0);
	dlg->ShowWindow(SW_SHOW);
	
	ctrlDlg = new CControlDlg(NULL);	//} Create the control dialog
	ctrlDlg->Create(IDD_CONTROLS, 0);	//}

	statDlg = new CStatusDlg(NULL);		//} Create the status dialog
	statDlg->Create(IDD_STATUS, 0);		//}

	AboutDlg = new CSDAboutDlg(NULL);
	AboutDlg->Create(IDD_ABOUT, 0);

	return TRUE;
}
/*--------------------------------------------------------------------------*/

void CR2D3InterruptApp::OnControl()
{
	ctrlDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/
void CR2D3InterruptApp::OnClose()
{
//	ctrlDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/

void CR2D3InterruptApp::OnStatus()
{
	statDlg->ShowWindow(SW_SHOW);
}
/*--------------------------------------------------------------------------*/
void CR2D3InterruptApp::OnAbout()
{
int CardType=0;
unsigned int CardSerNum=0;
CString buffer;
//CardSerNum=(gStatusRegister[9]& SER_NUM_UPR_MASK)<<28;
CardSerNum|=gStatusRegister[8] & SER_NUM_LWR_MASK;
buffer.Format(_T("%x"), CardSerNum);
//buffer.Format(_T("%d.%d"), CardType, CardSerNum);
AboutDlg->CardNo.SetWindowText(buffer);
AboutDlg->ShowWindow(SW_SHOW);
}
//-------------------------------------------------------------------
void CR2D3InterruptApp::OnRead()
{
int PBufPage;
//	DWORD Wait;
	
CMenu menu;
menu.LoadMenu(IDR_MENU1);

	/*UINT state = menu.GetMenuState(ID_READ, MF_BYCOMMAND);
	if (state & MF_CHECKED)
		menu.CheckMenuItem(ID_READ, MF_UNCHECKED | MF_BYCOMMAND);
	else
		menu.CheckMenuItem(ID_READ, MF_CHECKED | MF_BYCOMMAND);
	state = menu.GetMenuState(ID_READ, MF_BYCOMMAND);
	//Read1->Checked=!Read1->Checked;
	bool res = SetMenu(theApp.GetMainWnd()->GetSafeHwnd(), menu.GetSafeHmenu());
	*/
theApp.dlg->Read = !theApp.dlg->Read;
	

if(theApp.dlg->Read)
	{
		//menu.EnableMenuItem(ID_WRITE, MF_BYCOMMAND | MF_GRAYED);
		//SetMenu(theApp.GetMainWnd()->GetSafeHwnd(), menu.GetSafeHmenu());
  theApp.dlg->MyEnableMenuItem(ID_WRITE, MF_BYCOMMAND | MF_GRAYED);
		
		//SetMenu(&menu);
		//Write1->Enabled =false;
		
	theApp.dlg->LabelMessage.SetWindowText("No Message");
	theApp.dlg->LabelError.SetWindowText("No Error");
	theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
	theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
	theApp.dlg->gCommand2|=XFIFO_RESET;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	theApp.dlg->gCommand1|=INT_EN_THRESH_STRA;
	theApp.dlg->gCommand1|=INT_EN_THRESH_STRB;
	theApp.dlg->gCommand1|=INT_EN_THRESH_HI|INT_EN_COMMAND;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);
	theApp.dlg->gCommand1&=~INT_EN_COMMAND;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);

	theApp.dlg->gInterruptCommand|= S5933_INTCSR_READ_INTERRUPT;//dma	transfer
	EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
	theApp.dlg->gCommand2&=~STRA_RECORD&~STRA_FIFO_RESET;//&~STRA_UNFRAMED;
	theApp.dlg->gCommand2&=~STRB_RECORD&~STRB_FIFO_RESET;
	theApp.dlg->gCommand2&=~XFIFO_RESET;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	PBufPage=R2D3_BUF_SIZE/(pBufferThread->NumBytes);// fill
	ResetEvent(hDMAReadCompleteEvent);
	theApp.dlg->gCommand2|=STRA_DATA_REQ|REP_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	for(int n=0;n<PBufPage;n++)
		{
			//    CopyMemory(DmaBufferInfo.pVirtualAddress,pBufferThread->DataBuffer1,pBufferThread->NumBytes);
		pBufferThread-> WriteToCard(pBufferThread->NumBytes,true);
		}
	theApp.dlg->gStreamSelect&=~STRA_DATA_REQ;
	theApp.dlg->gCommand2&=~STRA_DATA_REQ&~REP_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	theApp.dlg->gCommand2|=STRB_DATA_REQ|REP_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);


	for(int  n=0;n<PBufPage;n++)
		{
			//    CopyMemory(DmaBufferInfo.pVirtualAddress,pBufferThread->DataBuffer2,pBufferThread->NumBytes);
		pBufferThread->WriteToCard(pBufferThread->NumBytes,false);
		}
	theApp.dlg->gCommand2&=~STRB_DATA_REQ&~REP_XFIFO_REQ;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);

	theApp.dlg->gInterruptCommand|=S5933_INTCSR_IN_MAILBOX_4|S5933_INTCSR_IN_BYTE_4|S5933_INTCSR_INCOMING_INTERRUPT;
	EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
	ResetEvent(hHiThreshIntEvent);//initial condition
		//set card to active, allow replay to start
	theApp.dlg->gCommand2|=STRA_START;
	theApp.dlg->gCommand2|= STRB_START;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//Read=true;
	SetEvent(hBufferGoEvent);
		//  pStatusDisplayThread->Resume();
	}
else
	{
		//  DiskReadBtn->Caption="Play Disk";
		//stop buffer thread
		//Read=false;
	ResetEvent(hBufferGoEvent);
		//close file
		//stop interrupts
	theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_READ_INTERRUPT;
	theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_INCOMING_INTERRUPT;
	EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
	theApp.dlg->gCommand1=0;
	theApp.dlg->gCommand1|=INT_EN_COMMAND;
	theApp.dlg->gCommand1&=~INT_EN_THRESH_HI&~INT_EN_THRESH_STRA&~INT_EN_THRESH_STRB;//&~STRA_DATA_REQ ;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);
	theApp.dlg->gCommand1&=~INT_EN_COMMAND;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);

	theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
	theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//Write1->Enabled =true;
	theApp.dlg->MyEnableMenuItem(ID_WRITE, MF_BYCOMMAND | MF_ENABLED);
	SetEvent(hHiThreshIntEvent);//frees waiting thread
	}
}
//----------------------------------------------------------------
void CR2D3InterruptApp::OnWrite()
{
//int PBufPage;
//DWORD Wait;
CMenu menu;
menu.LoadMenu(IDR_MENU1);

	/*UINT state = menu.GetMenuState(ID_WRITE, MF_BYCOMMAND);
	if (state & MF_CHECKED)
		menu.CheckMenuItem(ID_WRITE, MF_UNCHECKED | MF_BYCOMMAND);
	else
		menu.CheckMenuItem(ID_WRITE, MF_CHECKED | MF_BYCOMMAND);
	state = menu.GetMenuState(ID_WRITE, MF_BYCOMMAND);
//	SetMenu(menu);
	SetMenu(theApp.GetMainWnd()->GetSafeHwnd(), menu.GetSafeHmenu());*/
theApp.dlg->Write = !theApp.dlg->Write;
	//Write1->Checked=!Write1->Checked;
if(theApp.dlg->Write)
	{
	theApp.dlg->MyEnableMenuItem(ID_READ, MF_BYCOMMAND | MF_GRAYED);
		
	theApp.dlg->LabelMessage.SetWindowText("No Message");
	theApp.dlg->LabelError.SetWindowText("No Error");
		
	theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
		//reset main memory buffers
	theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
		//set card streams to record mode
	theApp.dlg->gCommand2|=STRA_RECORD|STRB_RECORD;
		//send the command to Outgoing mailbox 2
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//reset the cache fifo
	theApp.dlg->gCommand1|=XFIFO_RESET;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		//set up the card interrupts
	theApp.dlg->gCommand1|=INT_EN_THRESH_STRA;
	theApp.dlg->gCommand1|=INT_EN_THRESH_STRB;
	theApp.dlg->gCommand1|=INT_EN_THRESH_HI|INT_EN_COMMAND;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		//disable the card interrupt enable to confirm the interrupt selection
	theApp.dlg->gCommand1&=~INT_EN_COMMAND;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		//set up the AMCC interrupt control status register
	theApp.dlg->gInterruptCommand|= S5933_INTCSR_WRITE_INTERRUPT;//dma transfer
	theApp.dlg->gInterruptCommand|=S5933_INTCSR_IN_MAILBOX_4|S5933_INTCSR_IN_BYTE_4|S5933_INTCSR_INCOMING_INTERRUPT;
	EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		//lift the card buffer resets
	theApp.dlg->gCommand2&=~STRA_FIFO_RESET;
	theApp.dlg->gCommand2&=~STRB_FIFO_RESET;
	WriteMailBox1(OMB2, theApp.dlg->gCommand2);
	theApp.dlg->gCommand1&=~XFIFO_RESET;
	WriteMailBox1(OMB1, theApp.dlg->gCommand1);
	ResetEvent(hHiThreshIntEvent);//initial condition

		//set card to active, allow replay to start
	theApp.dlg->gCommand2|=STRA_START;
		theApp.dlg->gCommand2|= STRB_START;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		//Write=true;
		SetEvent(hBufferGoEvent);
		//  pStatusDisplayThread->Resume();

	}
	else
	{
		//  DiskReadBtn->Caption="Play Disk";
		//stop buffer thread
		//Write=false;
		ResetEvent(hBufferGoEvent);
		//stop interrupts
		theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_WRITE_INTERRUPT;
		theApp.dlg->gInterruptCommand&=~ S5933_INTCSR_INCOMING_INTERRUPT;
		EnableAmccInterrupts(theApp.dlg->gInterruptCommand);
		theApp.dlg->gCommand1|=INT_EN_COMMAND;
		theApp.dlg->gCommand1&=~INT_EN_THRESH_HI&~INT_EN_THRESH_STRA&~INT_EN_THRESH_STRB;//&~STRA_DATA_REQ ;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);
		theApp.dlg->gCommand1&=~INT_EN_COMMAND;
		WriteMailBox1(OMB1, theApp.dlg->gCommand1);

		theApp.dlg->gCommand2&=~STRA_START&~STRB_START;
		theApp.dlg->gCommand2|=STRA_FIFO_RESET|STRB_FIFO_RESET;
		WriteMailBox1(OMB2, theApp.dlg->gCommand2);
		SetEvent(hHiThreshIntEvent);//frees waiting thread
		theApp.dlg->MyEnableMenuItem(ID_READ, MF_BYCOMMAND | MF_ENABLED);
		//Read1->Enabled =true;
	}
}
//---------------------------------------------------------------------