// R2D3InterruptDlg.cpp : implementation file
//
/*-Includes-----------------------------------------------------------------*/
#include "stdafx.h"
#include "R2D3Interrupt.h"
#include "R2D3InterruptDlg.h"
#include ".\r2d3interruptdlg.h"
#include "r2d3dabctl.h"
#include "interruptthread.h"
#include "bufferthread.h"

/*-Defines------------------------------------------------------------------*/
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-Globals------------------------------------------------------------------*/
HANDLE hStatus_Display_Event;
bool isTerminated=false;
HANDLE hDMAWriteCompleteEvent;
HANDLE hDMAReadCompleteEvent;
HANDLE hHiThreshIntEvent;
HANDLE hBufferGoEvent;
HANDLE hBufferEventA;
HANDLE hBufferEventB;
CRITICAL_SECTION  csStatusUpdate;

CInterruptThread *pInterruptThread=NULL;
CBufferThread *pBufferThread=NULL;

/*-CAboutDlg Class----------------------------------------------------------*/
// Used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

/*-CAboutDlg Methods--------------------------------------------------------*/
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}
/*--------------------------------------------------------------------------*/

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}
/*--------------------------------------------------------------------------*/

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()
/*--------------------------------------------------------------------------*/

/*-CR2D3InterruptDlg Message Map----------------------------------------------*/

BEGIN_MESSAGE_MAP(CR2D3InterruptDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_CLOSE()
	ON_BN_CLICKED(ID_BTNOPEN, OnBnClickedBtnopen)
END_MESSAGE_MAP()

/*-CR2D3InterruptDlg Methods--------------------------------------------------*/

CR2D3InterruptDlg::CR2D3InterruptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CR2D3InterruptDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	gCommand1,gCommand2,gCommand3,gCommand4 = 0;
	
	gInterruptCommand = 0;
	
	gStreamSelect = 0;
  isOpenCard=false;
	Read = false;
	Write = false;

	//menu.LoadMenu(IDR_MENU1);
}
/*--------------------------------------------------------------------------*/

void CR2D3InterruptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_Control(pDX, IDC_LIST2, listBox2);
	//DDX_Control(pDX, IDC_LIST1, listBox1);
	DDX_Control(pDX, IDC_DISPLAY1, display1);
	DDX_Control(pDX, IDC_DISPLAY2, display2);

	DDX_Control(pDX, ID_BTNOPEN, OpenBtn);
	DDX_Control(pDX, IDC_ERROR, LabelError);
	DDX_Control(pDX, IDC_STATUS, StatusLabel);

	DDX_Control(pDX, IDC_MSG, LabelMessage);
}
/*--------------------------------------------------------------------------*/

// CR2D3InterruptDlg message handlers
BOOL CR2D3InterruptDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}
/*--------------------------------------------------------------------------*/

void CR2D3InterruptDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
/*--------------------------------------------------------------------------*/

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CR2D3InterruptDlg::OnPaint() 
{
if (IsIconic())
  {
	CPaintDC dc(this); // device context for painting

	SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
	int cxIcon = GetSystemMetrics(SM_CXICON);
	int cyIcon = GetSystemMetrics(SM_CYICON);
	CRect rect;
	GetClientRect(&rect);
	int x = (rect.Width() - cxIcon + 1) / 2;
	int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
	dc.DrawIcon(x, y, m_hIcon);
	}
else
	{
	CDialog::OnPaint();
	}
}
/*--------------------------------------------------------------------------*/
// The system calls this function to obtain the cursor to 
// display while the user drags the minimized window.
HCURSOR CR2D3InterruptDlg::OnQueryDragIcon()
{
return static_cast<HCURSOR>(m_hIcon);
}
/*--------------------------------------------------------------------------*/

void CR2D3InterruptDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
OnOK();
}
/*--------------------------------------------------------------------------*/

void CR2D3InterruptDlg::OnClose()
{
if(isOpenCard)
  OnBnClickedBtnopen();
isTerminated = true;
theApp.m_pMainWnd->DestroyWindow();
}
/*--------------------------------------------------------------------------*/
void CR2D3InterruptDlg::OnDestroy()
{
	//theApp.m_pMainWnd->DestroyWindow();
}
/*--------------------------------------------------------------------------*/
void CR2D3InterruptDlg::OnBnClickedBtnopen()
{
//	DWORD status;
extern HANDLE AmccWin32InterruptEvents[];
	
CMenu menu;
menu.LoadMenu(IDR_MENU1);
//	static bool OpenCard;
isOpenCard=!isOpenCard;
if(isOpenCard)
  {
	OpenPciAmcc();
	ResetAmcc();
	InitialiseCard();
		
	theApp.dlg->OpenBtn.SetWindowText("Close");
	int temp = menu.EnableMenuItem(ID_STATUS, MF_ENABLED);
	menu.EnableMenuItem(ID_CONTROL, MF_ENABLED);
	menu.EnableMenuItem(ID_ABOUT, MF_ENABLED);
	menu.EnableMenuItem(ID_READ, MF_ENABLED);
	menu.EnableMenuItem(ID_WRITE, MF_ENABLED);
	SetMenu(&menu);

	DriverOpen=true;
	hStatus_Display_Event = CreateEvent(NULL, true, false, NULL);
	hDMAWriteCompleteEvent = CreateEvent(NULL, true, false, NULL);
	hDMAReadCompleteEvent = CreateEvent(NULL, true, false, NULL);
		 
	hBufferGoEvent= CreateEvent(NULL, true, false, NULL);
	hBufferEventA= CreateEvent(NULL, true, false, NULL);
	hBufferEventB= CreateEvent(NULL, true, false, NULL);
	hHiThreshIntEvent= CreateEvent(NULL, true, false, NULL);
	InitializeCriticalSection(&csStatusUpdate);
  isTerminated=false;
	AfxBeginThread(statusThreadFunction, NULL, THREAD_PRIORITY_LOWEST, 0, 0);
	if(pInterruptThread==NULL)
		pInterruptThread=new CInterruptThread();
	
	if(pBufferThread==NULL)
		pBufferThread=new CBufferThread();
	}
else
	{
	if(Write)
		theApp.OnWrite();
	if(Read)
		theApp.OnRead();
	pBufferThread->Terminate();
  SetEvent(hBufferGoEvent);//free waiting thread
  SetEvent(hHiThreshIntEvent);		
  pBufferThread=NULL;
  isTerminated=true;
	SetEvent(hStatus_Display_Event);
  pInterruptThread->Terminate();
	SetEvent(AmccWin32InterruptEvents[0]);
  pInterruptThread=NULL;
  ClosePciAmcc();
  theApp.dlg->OpenBtn.SetWindowText("Open");
	CloseHandle(hDMAWriteCompleteEvent);
	CloseHandle(hDMAReadCompleteEvent);
	CloseHandle(hStatus_Display_Event);
	CloseHandle(hBufferEventA);
	CloseHandle(hBufferEventB);
	CloseHandle(hBufferGoEvent);
	CloseHandle(hHiThreshIntEvent);
	DeleteCriticalSection(&csStatusUpdate);

	menu.EnableMenuItem(ID_STATUS, MF_GRAYED);
	menu.EnableMenuItem(ID_CONTROL, MF_GRAYED);
	menu.EnableMenuItem(ID_ABOUT, MF_GRAYED);
	menu.EnableMenuItem(ID_WRITE, MF_GRAYED);
	menu.EnableMenuItem(ID_READ, MF_GRAYED);
	SetMenu(&menu);

//		theApp.dlg->listBox1.ResetContent();
//		theApp.dlg->listBox2.ResetContent();
	DriverOpen=false;
	}
}
//------------------------------------------------------------------------
void CR2D3InterruptDlg::InitialiseCard(void)
{
gCommand1=0;
gCommand2=0;
gCommand3=0;
gCommand4=0;
gCommand2&=~STRA_START&~STRA_INTCLK&~STRA_E2E;
gCommand2|=STRA_FIFO_RESET|STR_LOZ;//start terminated impedance
gCommand2&=~STRA_OP_ZERO;//
WriteMailBox1(OMB2, gCommand2);
	
gCommand2=0;
gCommand2|=AUTO_FRAME;	//start in auto
gCommand2|=STRB_FIFO_RESET;
gCommand2&=~STRB_OP_ZERO;//
WriteMailBox1(OMB2, gCommand2);

theApp.ctrlDlg->StrASliderLow.SetPos(32);
theApp.ctrlDlg->StrASliderHi.SetPos(32);
NMHDR Nmhdr;
LRESULT Result;
theApp.ctrlDlg->OnNMReleasedcaptureSlider2(&Nmhdr, &Result);
theApp.ctrlDlg->StrBSliderLow.SetPos(32);
theApp.ctrlDlg->StrBSliderHi.SetPos(32);
theApp.ctrlDlg->OnNMReleasedcaptureSlider4(&Nmhdr, &Result);
theApp.ctrlDlg->StrAImp2.SetCheck(BST_CHECKED);
theApp.ctrlDlg->OnBnClickedStrAImpMode();
theApp.ctrlDlg->StrAutoFrm.SetCheck(BST_CHECKED);
theApp.ctrlDlg->OnBnClickedStrAFramed();
}
//-------------------------------------------------------------------
void CR2D3InterruptDlg::MyEnableMenuItem(UINT nIDEnableItem, UINT nEnable)
{
CMenu menu;
menu.LoadMenu(IDR_MENU1);
menu.EnableMenuItem(ID_STATUS, MF_ENABLED | MF_BYCOMMAND);
menu.EnableMenuItem(ID_CONTROL, MF_ENABLED | MF_BYCOMMAND);
menu.EnableMenuItem(ID_ABOUT, MF_ENABLED | MF_BYCOMMAND);
menu.EnableMenuItem(ID_READ, MF_ENABLED | MF_BYCOMMAND);
menu.EnableMenuItem(ID_WRITE, MF_ENABLED | MF_BYCOMMAND);

menu.EnableMenuItem(nIDEnableItem, nEnable);
SetMenu(&menu);
}
